#ifndef Fps_H
#define Fps_H

#include <Zeichnung.h>

namespace Framework
{
	class Prozess; // Prozess.h
	class Bild; // Bild.h
	class Schrift; // Schrift.h
	class Fps; // aus dieser Datei
    class TextRenderer;

	class Fps : public Zeichnung
	{
	private:
		Prozess *pr;
		double i;
		int fpsCount;
		int nowFps;
		int nowCpu;
		int nowMem;
        TextRenderer *textRd;
		int sFarbe;

	public:
		// Konstruktor 
		Fps();
		// Destruktor 
		~Fps();
		// nicht constant
		void setSchriftZ( Schrift *schrift ); // setzt die Schrift
		void setSFarbe( int f ); // setzt die Schrift Farbe
		bool tick( double tickval ) override; // tick
		void render( Bild &zRObj ) override; // zeichnet nach zrObj
		// constant
		Schrift *getSchrift() const; // gibt die Schrift zurck
		Schrift *zSchrift() const;
		int getFarbe() const; // gibt die Farbe zurck
		int getFps() const; // gibt fps zurck
		int getCpu() const; // gibt die Cpu zurck
		int getMem() const; // gibt den Arbeitsspeicher zurck
	};
}

#endif