#pragma once

#include <Knopf.h>
#include <Bild.h>
#include <KSGScript.h>

using namespace Framework;
class KEBeschreibung;

class KEBEditor : public Zeichnung
{
private:
    Knopf *beschreibung;
    Knopf *titelBild;
    Knopf *mapBild;
    Knopf *ladenBild;
    BildZ *bild;
    KSGScript::KSGScriptEditor *text;
    HINSTANCE ksgs;
    Knopf *speichern;
    Knopf *importieren;
    Knopf *vorschau;
    int jetzt;
    bool sichtbar;
    unsigned char alpha;
    double tickVal;

public:
    // Konstruktor
    KEBEditor( Schrift *zSchrift, KEBeschreibung *zKeb );
    // Destruktor
    ~KEBEditor();
    // nicht constant
    void setSichtbar( bool s );
    void setText( Text *zText );
    void setBild( Bild *zBild );
    bool tick( double tv ) override;
    void doMausEreignis( MausEreignis &me ) override;
    void doTastaturEreignis( TastaturEreignis &te ) override;
    void render( Bild &zRObj ) override;
    // constant
    int getKNum( Knopf *zK ) const;
    Text *zBeschreibung() const;
    int getJetzt() const;
    bool istSichtbar() const;
};