#include "Einstellungen.h"
#include <MausEreignis.h>
#include "../../Global/Initialisierung.h"

// Inhalt der Einstellungen Klasse aus Einstellungen.h
// Konstruktor
Einstellungen::Einstellungen( Schrift *zSchrift, Fenster *zF )
{
	f = initFenster( zF->getBreite() / 2 - 250, zF->getHeight() / 2 - 250, 500, 500, zSchrift, 
					 Fenster::Style::normal | Fenster::Style::BodyHAlpha | Fenster::Style::BodyHintergrund | 
					 Fenster::Style::TitelHintergrund | Fenster::Style::TitelHAlpha, "Einstellungen" );
	f->removeStyle( Fenster::Style::Sichtbar );
	f->setKBgFarbe( 0xe0000000 );
	f->setTBgFarbe( 0xe0000000 );
	f->setSBgFarbe( 0xF0000000 );
	f->setClosingMeParam( this );
	f->setClosingMe( einstellungenSchlieenME );
	ok = initKnopf( 390, 450, 100, 20, zSchrift, Knopf::Style::Sichtbar, "Ok" );
	ok->setMausEreignisParameter( this );
	ok->setMausEreignis( einstellungenOkME );
	f->addMember( ok->getThis() );
	zF->addMember( f->getThis() );
	ref = 1;
}

// Destruktor
Einstellungen::~Einstellungen()
{
	f->release();
	ok->release();
}

// nicht constant
void Einstellungen::setSichtbar()
{
    // TODO
	//-------------------
	f->setStyle( Fenster::Style::Sichtbar, f->hatStyleNicht( Fenster::Style::Sichtbar ) );
}

bool Einstellungen::closeME( MausEreignis &me )
{
	if( me.id == ME_RLinks )
		f->removeStyle( Fenster::Style::Sichtbar );
	return 1;
}

bool Einstellungen::okME( MausEreignis &me )
{
	if( me.id == ME_RLinks )
	{
		f->removeStyle( Fenster::Style::Sichtbar );
        // TODO
		//-----------------------------
	}
	return 1;
}

// Reference Counting
Einstellungen *Einstellungen::getThis()
{
	ref++;
	return this;
}

Einstellungen *Einstellungen::release()
{
	ref--;
	if( !ref )
		delete this;
	return 0;
}


// Ereignisse
bool einstellungenSchlieenME( void *p, void *obj, MausEreignis me )
{
	if( !p )
		return 1;
	return ( (Einstellungen*)p )->closeME( me );
}

bool einstellungenOkME( void *p, void *obj, MausEreignis me )
{
	if( !p )
		return 1;
	return ( (Einstellungen*)p )->okME( me );
}