#ifndef NachLogin_H
#define NachLogin_H

#include "Titel/TitelLeiste.h"
#include "Chat/FreundesListe.h"
#include "Chat/ChatLeiste.h"
#include "Chat/NachrichtenListe.h"
#include "Spiele/Spiele.h"
#include "Shop/Shop.h"
#include "Account/AccountAnsehen.h"
#include "ImSpiel/ImSpiel.h"
#include <AufzeichnungV.h>
#include "Neuigkeiten/Neuigkeiten.h"
#include "Einstellungen/Einstellungen.h"
#include "MiniGames/MiniGames.h"
#include "Editor/Editor.h"

using namespace Framework;

enum NachLoginAnzeige
{
	NLALogin,
	NLANormal,
	NLAImSpiel,
	NLASpielVideo,
    NLAEditor
};

class NachLogin : public Zeichnung
{
private:
	Fenster *fenster;
	Fenster *leistenFenster;
	Schrift *schrift;
	Bildschirm *bildschirm;
	TitelLeiste *titel;
	FreundesListe *freunde;
	ChatLeiste *chatLeiste;
	NachrichtenListe *nachrichtenListe;
	Spiele *spielenFenster;
	Shop *shopFenster;
	AccountAnsehen *accountAnsehenFenster;
	MiniGames *mgFenster;
	Neuigkeiten *newsFenster;
	Editor *editorFenster;
	ImSpiel *imSpiel;
	AufzeichnungV *spielAufzeichnung;
	Einstellungen *op;
	NachLoginAnzeige status;
    EditorV *editor;

public:
	// Konstruktor
	NachLogin( Schrift *zSchrift, Bildschirm *zBildschirm );
	// Destruktor
	~NachLogin();
	// nicht constant
	void login(); // Initialisiert die Oberflche
	void logout(); // Setzt die Oberflche zurck
	void setSpielAufzeichnung( AufzeichnungV *video ); // Setzt die Spiel Aufzeichnung
	void setEditor( EditorV *editor ); // Setzt den Editor
	void setAnzeige( NachLoginAnzeige s ); // Setzt den Status des Programms
	void doMausEreignis( MausEreignis &me ) override;
	void doTastaturEreignis( TastaturEreignis &te ) override;
	bool tick( double tickVal ) override;
	void render( Bild &zRObj ) override;
	// constant
	TitelLeiste *zTitelLeiste() const;// gibt die Titelleiste zurck
	FreundesListe *zFreundesListe() const; // gibt die FreundesListe zurck
	ChatLeiste *zChatLeiste() const; // gibt die ChatLeiste zurck
	NachrichtenListe *zNachrichtenListe() const; // gibt die NachrichtenListe zurck
	Spiele *zSpielenFenster() const; // gibt das Spiele Fenster zurck
	Shop *zShopFenster() const; // gibt das Shop Fenster zurck
	AccountAnsehen *zAccountAnsehenFenster() const; // gibt das Account Ansehen Fenster zurck
	MiniGames *zMGFenster() const; // gibt das MiniGames Fenster zurck
	Neuigkeiten *zNewsFenster() const; // gibt das News Fenster zurck
	Editor *zEditorFenster() const; // Gibt das Editor Fenster zurck
	ImSpiel *zImSpiel() const; // Gibt das Im Spiel Zeichnung zurck
	Einstellungen *zEinstellungen() const; // Gibt das Einstellungen Zeichnung zurck
};

#endif;