#include "..\..\Global\Variablen.h"
#include "TitelLeiste.h"
#include <DateiSystem.h>
#include "..\..\Global\Initialisierung.h"
#include <Punkt.h>
#include <Datei.h>

// Inhalt der TitelLeisten Klasse aus Titelleiste.h
// Konstruktor
TitelLeiste::TitelLeiste( Fenster *zNachLogin, Schrift *zSchrift )
    : Thread()
{
    Bild *goldB = bilder->get( "system.ltdb/gold.jpg" );
    if( !goldB )
    {
        LTDBDatei *datei = new LTDBDatei();
        datei->setDatei( new Text( "data/bilder/system.ltdb" ) );
        datei->leseDaten( 0 );
        goldB = datei->laden( 0, new Text( "gold.jpg" ) );
        datei->release();
        bilder->add( "system.ltdb/gold.jpg", goldB->getThis() );
    }
    Bild *silberB = bilder->get( "system.ltdb/silber.jpg" );
    if( !silberB )
    {
        LTDBDatei *datei = new LTDBDatei();
        datei->setDatei( new Text( "data/bilder/system.ltdb" ) );
        datei->leseDaten( 0 );
        silberB = datei->laden( 0, new Text( "silber.jpg" ) );
        datei->release();
        bilder->add( "system.ltdb/silber.jpg", silberB->getThis() );
    }
    Bild *kupferB = bilder->get( "system.ltdb/kupfer.jpg" );
    if( !kupferB )
    {
        LTDBDatei *datei = new LTDBDatei();
        datei->setDatei( new Text( "data/bilder/system.ltdb" ) );
        datei->leseDaten( 0 );
        kupferB = datei->laden( 0, new Text( "kupfer.jpg" ) );
        datei->release();
        bilder->add( "system.ltdb/kupfer.jpg", kupferB->getThis() );
    }
    LTDBDatei *bilder = new LTDBDatei();
    bilder->setDatei( new Text( "data/bilder/system.ltdb" ) );
    bilder->leseDaten( 0 );
    closeBild = bilder->laden( 0, new Text( "schlieen.png" ) );
    einstellungenBild = bilder->laden( 0, new Text( "optionen.png" ) );
    bilder->setDatei( new Text( "data/client/bilder/titel.ltdb" ) );
    bilder->leseDaten( 0 );
    logoutBild = bilder->laden( 0, new Text( "logout.png" ) );
    Bild *hintergrund = bilder->laden( 0, new Text( "titelleiste.jpg" ) );
    bilder = bilder->release();
    Punkt bgr = BildschirmGre();
    version = initTextFeld( 1, 1, 200, 12, zSchrift, TextFeld::Style::Text | TextFeld::Style::Sichtbar, "client version: " );
    Datei *vDat = new Datei();
    vDat->setDatei( new Text( "data/version" ) );
    vDat->open( Datei::Style::lesen );
    char clientVersion[ 4 ] = { 0, 0, 0, 0 };
    vDat->lese( clientVersion, 4 );
    vDat->close();
    vDat = vDat->release();
    version->zText()->append( (int)clientVersion[ 3 ] );
    version->zText()->append( "." );
    version->zText()->append( (int)clientVersion[ 2 ] );
    version->zText()->append( "." );
    version->zText()->append( (int)clientVersion[ 1 ] );
    version->zText()->append( "." );
    version->zText()->append( (int)clientVersion[ 0 ] );
    close = initKnopf( bgr.x - 23, -1, 22, 22, 0, 0, "" );
    close->setStyle( Knopf::Style::Sichtbar | Knopf::Style::Erlaubt | Knopf::Style::Hintergrund | Knopf::Style::HBild | Knopf::Style::KlickBuffer | Knopf::Style::HAlpha | Knopf::Style::Rahmen );
    close->setRahmenFarbe( 0xFFFFFFFF );
    close->setRahmenBreite( 1 );
    close->setHintergrundBildZ( closeBild->getThis() );
    initToolTip( close, "Kolja-Strohm Games Client beenden.", zSchrift, hauptScreen );
    close->setMausEreignisParameter( this );
    close->setMausEreignis( titelLeisteSchlieenME );
    einstellungen = initKnopf( bgr.x - 44, -1, 22, 22, 0, 0, "" );
    einstellungen->setStyle( Knopf::Style::Sichtbar | Knopf::Style::Erlaubt | Knopf::Style::Hintergrund | Knopf::Style::HBild | Knopf::Style::KlickBuffer | Knopf::Style::HAlpha | Knopf::Style::Rahmen );
    einstellungen->setRahmenFarbe( 0xFFFFFFFF );
    einstellungen->setRahmenBreite( 1 );
    einstellungen->setHintergrundBildZ( einstellungenBild->getThis() );
    einstellungen->setMausEreignisParameter( this );
    einstellungen->setMausEreignis( titelLeisteEinstellungenME );
    initToolTip( einstellungen, "Einstellungen ndern.", zSchrift, hauptScreen );
    logout = initKnopf( bgr.x - 65, -1, 22, 22, 0, 0, "" );
    logout->setStyle( Knopf::Style::Sichtbar | Knopf::Style::Erlaubt | Knopf::Style::Hintergrund | Knopf::Style::HBild | Knopf::Style::KlickBuffer | Knopf::Style::HAlpha | Knopf::Style::Rahmen );
    logout->setRahmenFarbe( 0xFFFFFFFF );
    logout->setRahmenBreite( 1 );
    logout->setHintergrundBildZ( logoutBild->getThis() );
    logout->setMausEreignisParameter( this );
    logout->setMausEreignis( titelLeisteLogoutME );
    initToolTip( logout, "Ausloggen.", zSchrift, hauptScreen );
    news = initKnopf( bgr.x - 103, 67, 102, 32, zSchrift, Knopf::Style::Sichtbar, "Information" );
    news->setRahmenFarbe( 0xFFFFFFFF );
    news->setRahmenBreite( 1 );
    news->setMausEreignisParameter( this );
    news->setMausEreignis( titelLeisteNewsME );
    miniGames = initKnopf( bgr.x - 204, 67, 102, 32, zSchrift, Knopf::Style::Sichtbar, "Mini Games" );
    miniGames->setRahmenFarbe( 0xFFFFFFFF );
    miniGames->setRahmenBreite( 1 );
    miniGames->setMausEreignisParameter( this );
    miniGames->setMausEreignis( titelLeisteMiniGamesME );
    accountAnsehen = initKnopf( bgr.x - 305, 67, 102, 32, zSchrift, Knopf::Style::Sichtbar, "Account" );
    accountAnsehen->setRahmenFarbe( 0xFFFFFFFF );
    accountAnsehen->setRahmenBreite( 1 );
    accountAnsehen->setMausEreignisParameter( this );
    accountAnsehen->setMausEreignis( titelLeisteAccountAnsehenME );
    shop = initKnopf( bgr.x - 406, 67, 102, 32, zSchrift, Knopf::Style::Sichtbar, "Shop" );
    shop->setRahmenFarbe( 0xFFFFFFFF );
    shop->setRahmenBreite( 1 );
    shop->setMausEreignisParameter( this );
    shop->setMausEreignis( titelLeisteShopME );
    spielen = initKnopf( bgr.x - 507, 67, 102, 32, zSchrift, Knopf::Style::Sichtbar, "Spielen" );
    spielen->setRahmenFarbe( 0xFFFFFFFF );
    spielen->setRahmenBreite( 1 );
    spielen->setMausEreignisParameter( this );
    spielen->setMausEreignis( titelLeisteSpielenME );
    editor = initKnopf( bgr.x - 507, 35, 102, 32, zSchrift, 0, "Editor" );
    editor->setRahmenFarbe( 0xFFFFFFFF );
    editor->setRahmenBreite( 1 );
    editor->setMausEreignisParameter( this );
    editor->setMausEreignis( titelLeisteEditorME );
    info = initTextFeld( 200, 11, 300, 76, zSchrift, TextFeld::Style::Sichtbar | TextFeld::Style::Mehrzeilig | TextFeld::Style::Rahmen, "Wilkommen bei Kolja-Strohm Games!\nViel Spa beim spielen." );
    info->setRahmenFarbe( 0xFFFFFFFF );
    int minus = bgr.x / 2 - 254;
    if( minus < 511 )
        minus = 511;
    minus = bgr.x - 508 - minus;
    news->setPosition( news->getX() - minus, news->getY() );
    miniGames->setPosition( miniGames->getX() - minus, miniGames->getY() );
    accountAnsehen->setPosition( accountAnsehen->getX() - minus, accountAnsehen->getY() );
    shop->setPosition( shop->getX() - minus, shop->getY() );
    spielen->setPosition( spielen->getX() - minus, spielen->getY() );
    editor->setPosition( editor->getX() - minus, editor->getY() );
    fenster = new Fenster();
    fenster->setStyle( Fenster::Style::Sichtbar | Fenster::Style::BodyHintergrund | Fenster::Style::BodyHBild | Fenster::Style::Erlaubt | Fenster::Style::Rahmen );
    fenster->setRFarbe( 0xFFFFFFFF );
    fenster->setSize( bgr.x, 100 );
    fenster->setKBgBildZ( hintergrund );
    fenster->addMember( close->getThis() );
    fenster->addMember( einstellungen->getThis() );
    fenster->addMember( logout->getThis() );
    fenster->addMember( accountAnsehen->getThis() );
    fenster->addMember( spielen->getThis() );
    fenster->addMember( editor->getThis() );
    fenster->addMember( miniGames->getThis() );
    fenster->addMember( news->getThis() );
    fenster->addMember( shop->getThis() );
    fenster->addMember( info->getThis() );
    fenster->addMember( version->getThis() );

    kupfer = initTextFeld( fenster->getBreite() - 40, 70, 10, 20, zSchrift, TextFeld::Style::Text | TextFeld::Style::Center, "0" );
    silber = initTextFeld( kupfer->getX() - 40, 70, 10, 20, zSchrift, TextFeld::Style::Text | TextFeld::Style::Center, "0" );
    gold = initTextFeld( silber->getX() - 40, 70, 10, 20, zSchrift, TextFeld::Style::Text | TextFeld::Style::Center, "0" );
    goldBild = new BildZ();
    goldBild->setStyle( BildZ::Style::Sichtbar );
    goldBild->setBildZ( goldB );
    goldBild->setSize( 20, 20 );
    goldBild->setPosition( gold->getX() + gold->getBreite(), 70 );
    silberBild = new BildZ();
    silberBild->setStyle( BildZ::Style::Sichtbar );
    silberBild->setBildZ( silberB );
    silberBild->setSize( 20, 20 );
    silberBild->setPosition( silber->getX() + silber->getBreite(), 70 );
    kupferBild = new BildZ();
    kupferBild->setStyle( BildZ::Style::Sichtbar );
    kupferBild->setBildZ( kupferB );
    kupferBild->setSize( 20, 20 );
    kupferBild->setPosition( kupfer->getX() + kupfer->getBreite(), 70 );

    fenster->addMember( gold->getThis() );
    fenster->addMember( silber->getThis() );
    fenster->addMember( kupfer->getThis() );
    fenster->addMember( goldBild->getThis() );
    fenster->addMember( silberBild->getThis() );
    fenster->addMember( kupferBild->getThis() );
    zNachLogin->addMember( fenster->getThis() );
    next = new Array< int >();
    nextAnzahl = 0;
    rend = 0;
    start();
}

// Destruktor
TitelLeiste::~TitelLeiste()
{
    ende();
    if( closeBild )
        closeBild = closeBild->release();
    if( einstellungenBild )
        einstellungenBild = einstellungenBild->release();
    if( logoutBild )
        logoutBild = logoutBild->release();
    if( close )
        close = (Knopf *)close->release();
    if( einstellungen )
        einstellungen = (Knopf *)einstellungen->release();
    if( logout )
        logout = (Knopf *)logout->release();
    if( accountAnsehen )
        accountAnsehen = (Knopf *)accountAnsehen->release();
    if( spielen )
        spielen = (Knopf *)spielen->release();
    if( editor )
        editor = (Knopf *)editor->release();
    if( miniGames )
        miniGames = (Knopf *)miniGames->release();
    if( news )
        news = (Knopf *)news->release();
    if( shop )
        shop = (Knopf *)shop->release();
    if( info )
        info = (Knopf *)info->release();
    if( version )
        version = (Knopf *)version->release();
    if( fenster )
        fenster = (Fenster *)fenster->release();
    if( next )
        next = next->release();
    goldBild->release();
    silberBild->release();
    kupferBild->release();
    gold->release();
    silber->release();
    kupfer->release();
}

// nicht constant
void TitelLeiste::setImSpiel( bool imSpiel ) // aktiviert oder deaktiviert Knpfe
{
    close->setStyle( Knopf::Style::Erlaubt, !imSpiel );
    einstellungen->setStyle( Knopf::Style::Erlaubt, !imSpiel );
    logout->setStyle( Knopf::Style::Erlaubt, !imSpiel );
    accountAnsehen->setStyle( Knopf::Style::Erlaubt, !imSpiel );
    spielen->setStyle( Knopf::Style::Erlaubt, !imSpiel );
    editor->setStyle( Knopf::Style::Erlaubt, !imSpiel );
    miniGames->setStyle( Knopf::Style::Erlaubt, !imSpiel );
    news->setStyle( Knopf::Style::Erlaubt, !imSpiel );
    shop->setStyle( Knopf::Style::Erlaubt, !imSpiel );
}

void TitelLeiste::setImVideo( bool imVideo ) // aktiviert oder deaktiviert Knpfe
{
    einstellungen->setStyle( Knopf::Style::Erlaubt, !imVideo );
    accountAnsehen->setStyle( Knopf::Style::Erlaubt, !imVideo );
    spielen->setStyle( Knopf::Style::Erlaubt, !imVideo );
    editor->setStyle( Knopf::Style::Erlaubt, !imVideo );
    miniGames->setStyle( Knopf::Style::Erlaubt, !imVideo );
    news->setStyle( Knopf::Style::Erlaubt, !imVideo );
    shop->setStyle( Knopf::Style::Erlaubt, !imVideo );
}

bool TitelLeiste::druckSchlieen( MausEreignis & me ) // Schlieen wurde gedrckt
{
    if( me.id == ME_RLinks )
    {
        nachLogin->zNachrichtenListe()->addNachricht( new Text( "Schlieen" ), new Text( "Mchtest du den Client wirklich beenden?" ),
                                                      new Text( "Ja" ), new Text( "Nein" ), []()
        {
            nachLogin->zChatLeiste()->removeAll();
            if( loginClient &&loginClient->verbinde() )
            {
                loginClient->logout();
                loginClient->trenne( 1 );
            }
            PostQuitMessage( 0 );
        } );
    }
    return 1;
}

bool TitelLeiste::druckEinstellungen( MausEreignis & me ) // Einstellungen wurde gedrckt
{
    if( me.id == ME_RLinks )
        nachLogin->zEinstellungen()->setSichtbar();
    return 1;
}

bool TitelLeiste::druckLogout( MausEreignis & me ) // Logout wurde gedrckt
{
    if( me.id == ME_RLinks )
    {
        nachLogin->zNachrichtenListe()->addNachricht( new Text( "Logout" ), new Text( "Mchtest du dich wirklich ausloggen?" ),
                                                      new Text( "Ja" ), new Text( "Nein" ), []()
        {
            ::aktion = 3;
        } );
    }
    return 1;
}

bool TitelLeiste::druckSpielen( MausEreignis & me ) // Spielen wurde gedrckt
{
    if( me.id == ME_RLinks )
    {
        if( nachLogin->zSpielenFenster()->istSichtbar() && !nextAnzahl )
            return 1;
        next->add( 1, nextAnzahl );
        nextAnzahl++;
    }
    return 1;
}

bool TitelLeiste::druckAccountAnsehen( MausEreignis & me ) // AccountAnsehen wurde gedrckt
{
    if( me.id == ME_RLinks )
    {
        if( nachLogin->zAccountAnsehenFenster()->istSichtbar() && !nextAnzahl )
            return 1;
        next->add( 2, nextAnzahl );
        nextAnzahl++;
    }
    return 1;
}

bool TitelLeiste::druckMiniGames( MausEreignis & me ) // MiniGames wurde gedrckt
{
    if( me.id == ME_RLinks )
    {
        if( nachLogin->zMGFenster()->istSichtbar() && !nextAnzahl )
            return 1;
        next->add( 3, nextAnzahl );
        nextAnzahl++;
    }
    return 1;
}

bool TitelLeiste::druckNews( MausEreignis & me ) // News wurde gedrckt
{
    if( me.id == ME_RLinks )
    {
        if( nachLogin->zNewsFenster()->istSichtbar() && !nextAnzahl )
            return 1;
        next->add( 4, nextAnzahl );
        nextAnzahl++;
    }
    return 1;
}

bool TitelLeiste::druckShop( MausEreignis & me ) // Spielen wurde gedrckt
{
    if( me.id == ME_RLinks )
    {
        if( nachLogin->zShopFenster()->istSichtbar() && !nextAnzahl )
            return 1;
        next->add( 5, nextAnzahl );
        nextAnzahl++;
    }
    return 1;
}

bool TitelLeiste::druckEditor( MausEreignis & me ) // Spielen wurde gedrckt
{
    if( me.id == ME_RLinks )
    {
        if( nachLogin->zEditorFenster()->istSichtbar() && !nextAnzahl )
            return 1;
        next->add( 6, nextAnzahl );
        nextAnzahl++;
    }
    return 1;
}

void TitelLeiste::thread()
{
    while( 1 )
    {
        if( infoClient )
        {
            cs.lock();
            Text *infoTxt = new Text( "" );
            int typ = 0;
            bool b = infoClient->getInformationText( infoTxt, &typ );
            if( b &&infoTxt->getLength() )
                info->setText( infoTxt->getThis() );
            infoTxt = infoTxt->release();
            int k = infoClient->getKupfer();
            int s = k / 100;
            int g = s / 100;
            s = s % 100;
            k = k % 100;
            Text * gt = new Text();
            gt->append( g );
            Text * st = new Text();
            st->append( s );
            Text * kt = new Text();
            kt->append( k );
            Schrift * schrift = gold->zSchrift();
            TextRenderer rd( schrift->getThis() );
            rd.setSchriftSize( 12 );
            int gtbr = rd.getTextBreite( gt->getText() );
            int stbr = rd.getTextBreite( st->getText() );
            int ktbr = rd.getTextBreite( kt->getText() );
            kupfer->setPosition( fenster->getBreite() - 30 - ktbr, kupfer->getY() );
            kupfer->setSize( ktbr, 20 );
            silber->setPosition( kupfer->getX() - 30 - stbr, silber->getY() );
            silber->setSize( stbr, 20 );
            gold->setPosition( silber->getX() - 30 - gtbr, gold->getY() );
            gold->setSize( gtbr, 20 );
            goldBild->setPosition( gold->getX() + gold->getBreite(), goldBild->getY() );
            silberBild->setPosition( silber->getX() + silber->getBreite(), silberBild->getY() );
            kupferBild->setPosition( kupfer->getX() + kupfer->getBreite(), kupferBild->getY() );
            gold->setText( gt );
            silber->setText( st );
            kupfer->setText( kt );
            editor->setStyle( Knopf::Style::Sichtbar, infoClient->hatRecht( 1 ) );
            cs.unlock();
        }
        Sleep( 60 * 1000 );
    }
    run = 0;
}

bool TitelLeiste::tick() // tick
{
    if( nextAnzahl )
    {
        rend = 1;
        int n = next->hat( 0 ) ? next->get( 0 ) : 0;
        switch( n )
        {
        case 1: // Spielen
            // Andere Fenster Unsichtbar machen
            if( nachLogin->zShopFenster()->istSichtbar() )
            {
                if( !nachLogin->zShopFenster()->istAnimiert() )
                    nachLogin->zShopFenster()->setSichtbar( 0 );
                break;
            }
            if( nachLogin->zAccountAnsehenFenster()->istSichtbar() )
            {
                if( !nachLogin->zAccountAnsehenFenster()->istAnimiert() )
                    nachLogin->zAccountAnsehenFenster()->setSichtbar( 0 );
                break;
            }
            if( nachLogin->zMGFenster()->istSichtbar() )
            {
                if( !nachLogin->zMGFenster()->istAnimiert() )
                    nachLogin->zMGFenster()->setSichtbar( 0 );
                break;
            }
            if( nachLogin->zNewsFenster()->istSichtbar() )
            {
                if( !nachLogin->zNewsFenster()->istAnimiert() )
                    nachLogin->zNewsFenster()->setSichtbar( 0 );
                break;
            }
            if( nachLogin->zEditorFenster()->istSichtbar() )
            {
                if( !nachLogin->zEditorFenster()->istAnimiert() )
                    nachLogin->zEditorFenster()->setSichtbar( 0 );
                break;
            }
            // Fenster Sichtbar machen
            spielen->setAlphaFeldFarbe( 0x0000FF00 );
            accountAnsehen->setAlphaFeldFarbe( 0x5500FF00 );
            miniGames->setAlphaFeldFarbe( 0x5500FF00 );
            news->setAlphaFeldFarbe( 0x5500FF00 );
            shop->setAlphaFeldFarbe( 0x5500FF00 );
            editor->setAlphaFeldFarbe( 0x5500FF00 );
            nachLogin->zSpielenFenster()->setSichtbar( 1 );
            next->remove( 0 );
            nextAnzahl--;
            break;
        case 2: // Account ansehen
            // Andere Fenster Unsichtbar machen
            if( nachLogin->zSpielenFenster()->istSichtbar() )
            {
                if( !nachLogin->zSpielenFenster()->istAnimiert() )
                    nachLogin->zSpielenFenster()->setSichtbar( 0 );
                break;
            }
            if( nachLogin->zShopFenster()->istSichtbar() )
            {
                if( !nachLogin->zShopFenster()->istAnimiert() )
                    nachLogin->zShopFenster()->setSichtbar( 0 );
                break;
            }
            if( nachLogin->zMGFenster()->istSichtbar() )
            {
                if( !nachLogin->zMGFenster()->istAnimiert() )
                    nachLogin->zMGFenster()->setSichtbar( 0 );
                break;
            }
            if( nachLogin->zNewsFenster()->istSichtbar() )
            {
                if( !nachLogin->zNewsFenster()->istAnimiert() )
                    nachLogin->zNewsFenster()->setSichtbar( 0 );
                break;
            }
            if( nachLogin->zEditorFenster()->istSichtbar() )
            {
                if( !nachLogin->zEditorFenster()->istAnimiert() )
                    nachLogin->zEditorFenster()->setSichtbar( 0 );
                break;
            }
            // Fenster Sichtbar machen
            spielen->setAlphaFeldFarbe( 0x5500FF00 );
            accountAnsehen->setAlphaFeldFarbe( 0x0000FF00 );
            miniGames->setAlphaFeldFarbe( 0x5500FF00 );
            news->setAlphaFeldFarbe( 0x5500FF00 );
            shop->setAlphaFeldFarbe( 0x5500FF00 );
            editor->setAlphaFeldFarbe( 0x5500FF00 );
            nachLogin->zAccountAnsehenFenster()->setSichtbar( 1 );
            next->remove( 0 );
            nextAnzahl--;
            break;
        case 3: // MiniGames
            // Andere Fenster Unsichtbar machen
            if( nachLogin->zSpielenFenster()->istSichtbar() )
            {
                if( !nachLogin->zSpielenFenster()->istAnimiert() )
                    nachLogin->zSpielenFenster()->setSichtbar( 0 );
                break;
            }
            if( nachLogin->zShopFenster()->istSichtbar() )
            {
                if( !nachLogin->zShopFenster()->istAnimiert() )
                    nachLogin->zShopFenster()->setSichtbar( 0 );
                break;
            }
            if( nachLogin->zAccountAnsehenFenster()->istSichtbar() )
            {
                if( !nachLogin->zAccountAnsehenFenster()->istAnimiert() )
                    nachLogin->zAccountAnsehenFenster()->setSichtbar( 0 );
                break;
            }
            if( nachLogin->zNewsFenster()->istSichtbar() )
            {
                if( !nachLogin->zNewsFenster()->istAnimiert() )
                    nachLogin->zNewsFenster()->setSichtbar( 0 );
                break;
            }
            if( nachLogin->zEditorFenster()->istSichtbar() )
            {
                if( !nachLogin->zEditorFenster()->istAnimiert() )
                    nachLogin->zEditorFenster()->setSichtbar( 0 );
                break;
            }
            // Fenster Sichtbar machen
            spielen->setAlphaFeldFarbe( 0x5500FF00 );
            accountAnsehen->setAlphaFeldFarbe( 0x5500FF00 );
            miniGames->setAlphaFeldFarbe( 0x0000FF00 );
            news->setAlphaFeldFarbe( 0x5500FF00 );
            shop->setAlphaFeldFarbe( 0x5500FF00 );
            editor->setAlphaFeldFarbe( 0x5500FF00 );
            nachLogin->zMGFenster()->setSichtbar( 1 );
            next->remove( 0 );
            nextAnzahl--;
            break;
        case 4: // News
            // Andere Fenster Unsichtbar machen
            if( nachLogin->zSpielenFenster()->istSichtbar() )
            {
                if( !nachLogin->zSpielenFenster()->istAnimiert() )
                    nachLogin->zSpielenFenster()->setSichtbar( 0 );
                break;
            }
            if( nachLogin->zShopFenster()->istSichtbar() )
            {
                if( !nachLogin->zShopFenster()->istAnimiert() )
                    nachLogin->zShopFenster()->setSichtbar( 0 );
                break;
            }
            if( nachLogin->zAccountAnsehenFenster()->istSichtbar() )
            {
                if( !nachLogin->zAccountAnsehenFenster()->istAnimiert() )
                    nachLogin->zAccountAnsehenFenster()->setSichtbar( 0 );
                break;
            }
            if( nachLogin->zMGFenster()->istSichtbar() )
            {
                if( !nachLogin->zMGFenster()->istAnimiert() )
                    nachLogin->zMGFenster()->setSichtbar( 0 );
                break;
            }
            if( nachLogin->zEditorFenster()->istSichtbar() )
            {
                if( !nachLogin->zEditorFenster()->istAnimiert() )
                    nachLogin->zEditorFenster()->setSichtbar( 0 );
                break;
            }
            // Fenster Sichtbar machen
            spielen->setAlphaFeldFarbe( 0x5500FF00 );
            accountAnsehen->setAlphaFeldFarbe( 0x5500FF00 );
            miniGames->setAlphaFeldFarbe( 0x5500FF00 );
            news->setAlphaFeldFarbe( 0x0000FF00 );
            shop->setAlphaFeldFarbe( 0x5500FF00 );
            editor->setAlphaFeldFarbe( 0x5500FF00 );
            nachLogin->zNewsFenster()->setSichtbar( 1 );
            next->remove( 0 );
            nextAnzahl--;
            break;
        case 5: // Shop
            // Andere Fenster Unsichtbar machen
            if( nachLogin->zSpielenFenster()->istSichtbar() )
            {
                if( !nachLogin->zSpielenFenster()->istAnimiert() )
                    nachLogin->zSpielenFenster()->setSichtbar( 0 );
                break;
            }
            if( nachLogin->zAccountAnsehenFenster()->istSichtbar() )
            {
                if( !nachLogin->zAccountAnsehenFenster()->istAnimiert() )
                    nachLogin->zAccountAnsehenFenster()->setSichtbar( 0 );
                break;
            }
            if( nachLogin->zMGFenster()->istSichtbar() )
            {
                if( !nachLogin->zMGFenster()->istAnimiert() )
                    nachLogin->zMGFenster()->setSichtbar( 0 );
                break;
            }
            if( nachLogin->zNewsFenster()->istSichtbar() )
            {
                if( !nachLogin->zNewsFenster()->istAnimiert() )
                    nachLogin->zNewsFenster()->setSichtbar( 0 );
                break;
            }
            if( nachLogin->zEditorFenster()->istSichtbar() )
            {
                if( !nachLogin->zEditorFenster()->istAnimiert() )
                    nachLogin->zEditorFenster()->setSichtbar( 0 );
                break;
            }
            // Fenster Sichtbar machen
            spielen->setAlphaFeldFarbe( 0x5500FF00 );
            accountAnsehen->setAlphaFeldFarbe( 0x5500FF00 );
            miniGames->setAlphaFeldFarbe( 0x5500FF00 );
            news->setAlphaFeldFarbe( 0x5500FF00 );
            shop->setAlphaFeldFarbe( 0x0000FF00 );
            editor->setAlphaFeldFarbe( 0x5500FF00 );
            nachLogin->zShopFenster()->setSichtbar( 1 );
            next->remove( 0 );
            nextAnzahl--;
            break;
        case 6: // Editor
            // Andere Fenster Unsichtbar machen
            if( nachLogin->zSpielenFenster()->istSichtbar() )
            {
                if( !nachLogin->zSpielenFenster()->istAnimiert() )
                    nachLogin->zSpielenFenster()->setSichtbar( 0 );
                break;
            }
            if( nachLogin->zAccountAnsehenFenster()->istSichtbar() )
            {
                if( !nachLogin->zAccountAnsehenFenster()->istAnimiert() )
                    nachLogin->zAccountAnsehenFenster()->setSichtbar( 0 );
                break;
            }
            if( nachLogin->zMGFenster()->istSichtbar() )
            {
                if( !nachLogin->zMGFenster()->istAnimiert() )
                    nachLogin->zMGFenster()->setSichtbar( 0 );
                break;
            }
            if( nachLogin->zNewsFenster()->istSichtbar() )
            {
                if( !nachLogin->zNewsFenster()->istAnimiert() )
                    nachLogin->zNewsFenster()->setSichtbar( 0 );
                break;
            }
            if( nachLogin->zShopFenster()->istSichtbar() )
            {
                if( !nachLogin->zShopFenster()->istAnimiert() )
                    nachLogin->zShopFenster()->setSichtbar( 0 );
                break;
            }
            // Fenster Sichtbar machen
            spielen->setAlphaFeldFarbe( 0x5500FF00 );
            accountAnsehen->setAlphaFeldFarbe( 0x5500FF00 );
            miniGames->setAlphaFeldFarbe( 0x5500FF00 );
            news->setAlphaFeldFarbe( 0x5500FF00 );
            shop->setAlphaFeldFarbe( 0x5500FF00 );
            editor->setAlphaFeldFarbe( 0x0000FF00 );
            nachLogin->zEditorFenster()->setSichtbar( 1 );
            next->remove( 0 );
            nextAnzahl--;
            break;
        }
    }
    bool ret = rend;
    rend = 0;
    return ret;
}

// constant
int TitelLeiste::getSpielenX() const
{
    return spielen->getX();
}

// Ereignisse
bool titelLeisteSchlieenME( void *p, void *obj, MausEreignis me )
{
    return ( (TitelLeiste *)p )->druckSchlieen( me );
}

bool titelLeisteEinstellungenME( void *p, void *obj, MausEreignis me )
{
    return ( (TitelLeiste *)p )->druckEinstellungen( me );
}

bool titelLeisteLogoutME( void *p, void *obj, MausEreignis me )
{
    return ( (TitelLeiste *)p )->druckLogout( me );
}

bool titelLeisteAccountAnsehenME( void *p, void *obj, MausEreignis me )
{
    return ( (TitelLeiste *)p )->druckAccountAnsehen( me );
}

bool titelLeisteSpielenME( void *p, void *obj, MausEreignis me )
{
    return ( (TitelLeiste *)p )->druckSpielen( me );
}

bool titelLeisteMiniGamesME( void *p, void *obj, MausEreignis me )
{
    return ( (TitelLeiste *)p )->druckMiniGames( me );
}

bool titelLeisteNewsME( void *p, void *obj, MausEreignis me )
{
    return ( (TitelLeiste *)p )->druckNews( me );
}

bool titelLeisteShopME( void *p, void *obj, MausEreignis me )
{
    return ( (TitelLeiste *)p )->druckShop( me );
}

bool titelLeisteEditorME( void *p, void *obj, MausEreignis me )
{
    return ( (TitelLeiste *)p )->druckEditor( me );
}