#ifndef TitelLeiste_H
#define TitelLeiste_H

#include <Klient.h>
#include <Knopf.h>
#include <Fenster.h>
#include <Bild.h>
#include <Thread.h>

using namespace Framework;

class TitelLeiste : public Thread
{
private:
	Knopf *close;
	Knopf *einstellungen;
	Knopf *logout;
	Knopf *accountAnsehen;
	Knopf *spielen;
	Knopf *miniGames;
	Knopf *news;
	Knopf *shop;
	Knopf *editor;
	Bild *closeBild;
	Bild *einstellungenBild;
	Bild *logoutBild;
	TextFeld *info;
	TextFeld *version;
	Fenster *fenster;
	Array< int > *next;
	Critical cs;
	BildZ *goldBild;
	BildZ *silberBild;
	BildZ *kupferBild;
	TextFeld *gold;
	TextFeld *silber;
	TextFeld *kupfer;
	int nextAnzahl;
	bool rend;

public:
	// Konstruktor
	TitelLeiste( Fenster *zNachLogin, Schrift *zSchrift );
	// Destruktor
	~TitelLeiste();
	// nicht constant
	void setImSpiel( bool imSpiel ); // aktiviert oder deaktiviert Knpfe
	void setImVideo( bool imVideo ); // aktiviert oder deaktiviert Knpfe
	bool druckSchlieen( MausEreignis &me ); // Schlieen wurde gedrckt
	bool druckEinstellungen( MausEreignis &me ); // Einstellungen wurde gedrckt
	bool druckLogout( MausEreignis &me ); // Logout wurde gedrckt
	bool druckAccountAnsehen( MausEreignis &me ); // AccountAnsehen wurde gedrckt
	bool druckSpielen( MausEreignis &me ); // Spielen wurde gedrckt
	bool druckMiniGames( MausEreignis &me ); // MiniGames wurde gedrckt
	bool druckNews( MausEreignis &me ); // News wurde gedrckt
	bool druckShop( MausEreignis &me ); // Shop wurde gedrckt
	bool druckEditor( MausEreignis &me ); // Shop wurde gedrckt
	void thread(); // aktualisierungs Thread
	bool tick(); // tick
	// constant
	int getSpielenX() const;
};

// Ereignisse
bool titelLeisteSchlieenME( void *p, void *obj, MausEreignis me );
bool titelLeisteEinstellungenME( void *p, void *obj, MausEreignis me );
bool titelLeisteLogoutME( void *p, void *obj, MausEreignis me );
bool titelLeisteAccountAnsehenME( void *p, void *obj, MausEreignis me );
bool titelLeisteSpielenME( void *p, void *obj, MausEreignis me );
bool titelLeisteMiniGamesME( void *p, void *obj, MausEreignis me );
bool titelLeisteNewsME( void *p, void *obj, MausEreignis me );
bool titelLeisteShopME( void *p, void *obj, MausEreignis me );
bool titelLeisteEditorME( void *p, void *obj, MausEreignis me );

#endif