#include "..\..\Global\Variablen.h"
#include "..\..\Global\Initialisierung.h"
#include "EMail.h"
#include <Text.h>
#include <Punkt.h>

// Inhalt der EMailndern Klasse aus EMail.h
// Konstruktor
EMailndern::EMailndern( Schrift *zSchrift, Fenster *zVorLoginFenster )
{
    Punkt bildschirmmitte = Bildschirmmitte();
    eMailndern = initKnopf( 10, 210, 130, 30, zSchrift, Knopf::Style::Sichtbar, "E-Mail ndern" );
    eMailndern->setMausEreignisParameter( this );
    eMailndern->setMausEreignis( eMailndernEMailndernME );
    initToolTip( eMailndern, "Account E-Mail Adresse ndern.", zSchrift, hauptScreen );
    zVorLoginFenster->addMember( eMailndern->getThis() );
    fenster = initFenster( bildschirmmitte.x - 125, bildschirmmitte.y - 100, 250, 200, zSchrift, Fenster::Style::Erlaubt | Fenster::Style::Rahmen | Fenster::Style::Titel | Fenster::Style::TitelBuffered, "E-Mail ndern" );
    name = initTextFeld( 20, 20, 208, 20, zSchrift, TextFeld::Style::TextFeld, "Name" );
    name->setTastaturEreignisParameter( this );
    name->setTastaturEreignis( eMailndernNameTE );
    initToolTip( name, "Account Name.", zSchrift, hauptScreen );
    fenster->addMember( name->getThis() );
    passwort = initTextFeld( 20, 50, 208, 20, zSchrift, TextFeld::Style::TextFeld, "Passwort" );
    passwort->setTastaturEreignisParameter( this );
    passwort->setTastaturEreignis( eMailndernPasswortTE );
    initToolTip( passwort, "Account Passwort.", zSchrift, hauptScreen );
    fenster->addMember( passwort->getThis() );
    geheimnis = initTextFeld( 20, 80, 208, 20, zSchrift, TextFeld::Style::TextFeld, "Geheimis" );
    geheimnis->setTastaturEreignisParameter( this );
    geheimnis->setTastaturEreignis( eMailndernGeheimnisTE );
    initToolTip( geheimnis, "Account Geheimnis.", zSchrift, hauptScreen );
    fenster->addMember( geheimnis->getThis() );
    nEMail = initTextFeld( 20, 110, 208, 20, zSchrift, TextFeld::Style::TextFeld, "neue E-Mail Adresse" );
    nEMail->setTastaturEreignisParameter( this );
    nEMail->setTastaturEreignis( eMailndernNEMailTE );
    initToolTip( nEMail, "Neue E-Mail Adresse.", zSchrift, hauptScreen );
    fenster->addMember( nEMail->getThis() );
    weiter = initKnopf( 74, 140, 100, 20, zSchrift, Knopf::Style::Sichtbar, "weiter" );
    weiter->setMausEreignisParameter( this );
    weiter->setMausEreignis( eMailndernWeiterME );
    nachricht = initTextFeld( 0, 5, 255, 150, zSchrift, TextFeld::Style::HCenter | TextFeld::Style::Mehrzeilig, "" );
    fenster->addMember( nachricht->getThis() );
    fenster->addMember( weiter->getThis() );
    zVorLoginFenster->addMember( fenster->getThis() );
    ref = 1;
}

// Destruktor
EMailndern::~EMailndern()
{
    if( eMailndern )
        eMailndern = (Knopf *)eMailndern->release();
    if( fenster )
        fenster = (Fenster *)fenster->release();
    if( name )
        name = (TextFeld *)name->release();
    if( passwort )
        passwort = (TextFeld *)passwort->release();
    if( geheimnis )
        geheimnis = (TextFeld *)geheimnis->release();
    if( nEMail )
        nEMail = (TextFeld *)nEMail->release();
    if( weiter )
        weiter = (Knopf *)weiter->release();
    if( nachricht )
        nachricht = (TextFeld *)nachricht->release();
}

// Privat
void EMailndern::zeigeNachricht( const char *txt )
{
    Punkt bildschirmmitte = Bildschirmmitte();
    name->removeStyle( TextFeld::Style::Sichtbar );
    passwort->removeStyle( TextFeld::Style::Sichtbar );
    geheimnis->removeStyle( TextFeld::Style::Sichtbar );
    nEMail->removeStyle( TextFeld::Style::Sichtbar );
    fenster->setSize( 250, 150 );
    fenster->setPosition( bildschirmmitte.x - 125, bildschirmmitte.y - 75 );
    weiter->setPosition( 139, 100 );
    weiter->setText( "Ok" );
    nachricht->setText( txt );
    if( nachricht->zText()->getLength() > 30 )
    {
        int pos = -1;
        bool set = 0;
        int lastp = 0;
        for( int i = 20; i < nachricht->zText()->getLength(); )
        {
            char *tmp = &nachricht->zText()->getText()[ i ];
            while( *tmp != ' ' && i < nachricht->zText()->getLength() )
            {
                tmp++;
                i++;
                if( i - 30 >= lastp )
                {
                    if( set )
                    {
                        lastp = pos;
                        set = 0;
                        nachricht->zText()->getText()[ pos ] = '\n';
                    }
                    else
                        lastp += 5;
                }
            }
            if( i < nachricht->zText()->getLength() )
            {
                pos = i;
                set = 1;
                tmp++;
                i++;
            }
        }
    }
    nachricht->addStyle( TextFeld::Style::Sichtbar );
}

// Knopfdruck
void EMailndern::druckFremdKnopf() // Ein anderer Knopf wurde gedrckt
{
    fenster->removeStyle( Fenster::Style::Sichtbar );
    eMailndern->setRahmenBreite( 2 );
    eMailndern->setAlphaFeldFarbe( 0x5500FF00 );
    eMailndern->setAlphaFeldStrength( -5 );
}

bool EMailndern::eMailndernME( void *obj, MausEreignis me ) // MausEreignis im Knopf eMailndern
{
    if( me.id == ME_RLinks )
    {
        vorLogin->setEMailndern();

        eMailndern->setRahmenBreite( 3 );
        eMailndern->setAlphaFeldFarbe( 0xFF000000 );
        eMailndern->setAlphaFeldStrength( 20 );
        Punkt bildschirmmitte = Bildschirmmitte();
        fenster->setSize( 255, 200 );
        fenster->setPosition( bildschirmmitte.x - 125, bildschirmmitte.y - 100 );
        fenster->addStyle( Fenster::Style::Sichtbar );
        nachricht->removeStyle( TextFeld::Style::Sichtbar );
        weiter->setText( "weiter" );
        weiter->setPosition( 75, 140 );
        name->addStyle( TextFeld::Style::Sichtbar );
        passwort->addStyle( TextFeld::Style::Sichtbar );
        geheimnis->addStyle( TextFeld::Style::Sichtbar );
        nEMail->addStyle( TextFeld::Style::Sichtbar );
        name->addStyle( TextFeld::Style::Fokus );
        name->setAuswahl( 0, name->zText()->getLength() );
    }
    return 1;
}

bool EMailndern::nameTE( void *obj, TastaturEreignis te ) // Tastaturereignis im Textfeld name
{
    if( te.id == TE_Press && te.taste == T_Enter )
        return 0;
    if( te.id == TE_Release && ( te.taste == T_Enter || te.taste == T_Tab ) )
    {
        name->removeStyle( TextFeld::Style::Fokus );
        passwort->addStyle( TextFeld::Style::Fokus );
        passwort->setAuswahl( 0, passwort->zText()->getLength() );
    }
    if( name->zText()->getLength() >= 25 && istSchreibbar( te.taste ) )
        return 0;
    return 1;
}

bool EMailndern::passwortTE( void *obj, TastaturEreignis te ) // Tastaturereignis im Textfeld passwort
{
    if( te.id == TE_Press && te.taste == T_Enter )
        return 0;
    if( te.id == TE_Press )
        passwort->setSchowChar( '*' );
    if( te.id == TE_Release && ( te.taste == T_Enter || te.taste == T_Tab ) )
    {
        passwort->removeStyle( TextFeld::Style::Fokus );
        geheimnis->addStyle( TextFeld::Style::Fokus );
        geheimnis->setAuswahl( 0, geheimnis->zText()->getLength() );
    }
    if( passwort->zText()->getLength() >= 25 && istSchreibbar( te.taste ) )
        return 0;
    return 1;
}

bool EMailndern::geheimnisTE( void *obj, TastaturEreignis te ) // Tastaturereignis im Textfeld geheimnis
{
    if( te.id == TE_Press && te.taste == T_Enter )
        return 0;
    if( te.id == TE_Press )
        geheimnis->setSchowChar( '*' );
    if( te.id == TE_Release && ( te.taste == T_Enter || te.taste == T_Tab ) )
    {
        geheimnis->removeStyle( TextFeld::Style::Fokus );
        nEMail->addStyle( TextFeld::Style::Fokus );
        nEMail->setAuswahl( 0, nEMail->zText()->getLength() );
    }
    if( geheimnis->zText()->getLength() >= 50 && istSchreibbar( te.taste ) )
        return 0;
    return 1;
}

bool EMailndern::nEMailTE( void *obj, TastaturEreignis te ) // Tastaturereignis im Textfeld nEMail
{
    if( te.id == TE_Press && te.taste == T_Enter )
        return 0;
    if( te.id == TE_Press )
        nEMail->setSchowChar( '*' );
    if( te.id == TE_Release && te.taste == T_Enter )
    {
        nEMail->removeStyle( TextFeld::Style::Fokus );
        MausEreignis me;
        me.id = ME_RLinks;
        weiterME( 0, me );
    }
    if( nEMail->zText()->getLength() >= 50 && istSchreibbar( te.taste ) )
        return 0;
    return 1;
}

bool EMailndern::weiterME( void *obj, MausEreignis me ) // MausEreignis im Knopf weiter
{
    if( me.id == ME_RLinks )
    {
        if( weiter->zText()->istGleich( "weiter" ) )
        {
            if( name->zText()->getLength() == 0 )
                zeigeNachricht( "Bitte gebe deinen Accountnamen ein." );
            if( passwort->zText()->getLength() == 0 )
                zeigeNachricht( "Bitte gebe dein Accountpasswort ein." );
            if( geheimnis->zText()->getLength() == 0 )
                zeigeNachricht( "Bitte gebe dein Accountgeheimnis ein." );
            if( nEMail->zText()->getLength() == 0 )
                zeigeNachricht( "Bitte gebe eine neue E-Mail Addresse ein." );
            if( weiter->zText()->istGleich( "Ok" ) )
                return 1;
            new AktionsThread( 8, name->zText()->getText(), passwort->zText()->getText(), geheimnis->zText()->getText(), nEMail->zText()->getText(), 0 );
        }
        else
        {
            Punkt bildschirmmitte = Bildschirmmitte();
            fenster->setSize( 255, 200 );
            fenster->setPosition( bildschirmmitte.x - 125, bildschirmmitte.y - 100 );
            fenster->addStyle( Fenster::Style::Sichtbar );
            nachricht->removeStyle( TextFeld::Style::Sichtbar );
            weiter->setText( "weiter" );
            weiter->setPosition( 75, 140 );
            name->addStyle( TextFeld::Style::Sichtbar );
            passwort->addStyle( TextFeld::Style::Sichtbar );
            geheimnis->addStyle( TextFeld::Style::Sichtbar );
            nEMail->addStyle( TextFeld::Style::Sichtbar );
            name->addStyle( TextFeld::Style::Fokus );
            name->setAuswahl( 0, name->zText()->getLength() );
        }
    }
    return 1;
}

void EMailndern::setReturn( bool ret ) // Setzt den Returnwert
{
    if( ret )
        zeigeNachricht( "E-Mail erfolgreich gendert." );
    else if( lastError.getLength() )
        zeigeNachricht( lastError );
    else
        zeigeNachricht( "Es ist ein Unbekannter Fehler aufgetreten." );
}

// Reference Counting
EMailndern * EMailndern::getThis()
{
    ref++;
    return this;
}

EMailndern *EMailndern::release()
{
    ref--;
    if( !ref )
        delete this;
    return 0;
}


// Inhalt der EMailVergessen Klasse aus EMail.h
// Konstruktor
EMailVergessen::EMailVergessen( Schrift * zSchrift, Fenster * zVorLoginFenster )
{
    Punkt bildschirmmitte = Bildschirmmitte();
    eMailVergessen = initKnopf( 10, 410, 130, 30, zSchrift, Knopf::Style::Sichtbar, "E-Mail vergessen" );
    eMailVergessen->setMausEreignisParameter( this );
    eMailVergessen->setMausEreignis( eMailVergessenEMailVergessenME );
    initToolTip( eMailVergessen, "Account E-Mail Adresse anzeigen.", zSchrift, hauptScreen );
    zVorLoginFenster->addMember( eMailVergessen->getThis() );
    fenster = initFenster( bildschirmmitte.x - 125, bildschirmmitte.y - 85, 250, 170, zSchrift, Fenster::Style::Erlaubt | Fenster::Style::Rahmen | Fenster::Style::Titel | Fenster::Style::TitelBuffered, "E-Mail vergessen" );
    name = initTextFeld( 20, 20, 208, 20, zSchrift, TextFeld::Style::TextFeld, "Name" );
    name->setTastaturEreignisParameter( this );
    name->setTastaturEreignis( eMailVergessenNameTE );
    initToolTip( name, "Account Name.", zSchrift, hauptScreen );
    fenster->addMember( name->getThis() );
    passwort = initTextFeld( 20, 50, 208, 20, zSchrift, TextFeld::Style::TextFeld, "Passwort" );
    passwort->setTastaturEreignisParameter( this );
    passwort->setTastaturEreignis( eMailVergessenPasswortTE );
    initToolTip( passwort, "Account Passwort.", zSchrift, hauptScreen );
    fenster->addMember( passwort->getThis() );
    geheimnis = initTextFeld( 20, 80, 208, 20, zSchrift, TextFeld::Style::TextFeld, "Geheimis" );
    geheimnis->setTastaturEreignisParameter( this );
    geheimnis->setTastaturEreignis( eMailVergessenGeheimnisTE );
    initToolTip( geheimnis, "Account Geheimnis.", zSchrift, hauptScreen );
    fenster->addMember( geheimnis->getThis() );
    weiter = initKnopf( 74, 110, 100, 20, zSchrift, Knopf::Style::Sichtbar, "weiter" );
    weiter->setMausEreignisParameter( this );
    weiter->setMausEreignis( eMailVergessenWeiterME );
    nachricht = initTextFeld( 0, 5, 255, 150, zSchrift, TextFeld::Style::HCenter | TextFeld::Style::Mehrzeilig, "" );
    fenster->addMember( nachricht->getThis() );
    fenster->addMember( weiter->getThis() );
    zVorLoginFenster->addMember( fenster->getThis() );
    ref = 1;
}

// Destruktor
EMailVergessen::~EMailVergessen()
{
    if( eMailVergessen )
        eMailVergessen = (Knopf *)eMailVergessen->release();
    if( fenster )
        fenster = (Fenster *)fenster->release();
    if( name )
        name = (TextFeld *)name->release();
    if( passwort )
        passwort = (TextFeld *)passwort->release();
    if( geheimnis )
        geheimnis = (TextFeld *)geheimnis->release();
    if( weiter )
        weiter = (Knopf *)weiter->release();
    if( nachricht )
        nachricht = (TextFeld *)nachricht->release();
}

// Privat
void EMailVergessen::zeigeNachricht( const char *txt )
{
    Punkt bildschirmmitte = Bildschirmmitte();
    name->removeStyle( TextFeld::Style::Sichtbar );
    passwort->removeStyle( TextFeld::Style::Sichtbar );
    geheimnis->removeStyle( TextFeld::Style::Sichtbar );
    fenster->setSize( 250, 150 );
    fenster->setPosition( bildschirmmitte.x - 125, bildschirmmitte.y - 75 );
    weiter->setPosition( 139, 100 );
    weiter->setText( "Ok" );
    nachricht->setText( txt );
    if( nachricht->zText()->getLength() > 30 )
    {
        int pos = -1;
        bool set = 0;
        int lastp = 0;
        for( int i = 20; i < nachricht->zText()->getLength(); )
        {
            char *tmp = &nachricht->zText()->getText()[ i ];
            while( *tmp != ' ' && i < nachricht->zText()->getLength() )
            {
                tmp++;
                i++;
                if( i - 30 >= lastp )
                {
                    if( set )
                    {
                        lastp = pos;
                        set = 0;
                        nachricht->zText()->getText()[ pos ] = '\n';
                    }
                    else
                        lastp += 5;
                }
            }
            if( i < nachricht->zText()->getLength() )
            {
                pos = i;
                set = 1;
                tmp++;
                i++;
            }
        }
    }
    nachricht->addStyle( TextFeld::Style::Sichtbar );
}

// Knopfdruck
void EMailVergessen::druckFremdKnopf() // Ein anderer Knopf wurde gedrckt
{
    fenster->removeStyle( Fenster::Style::Sichtbar );
    eMailVergessen->setRahmenBreite( 2 );
    eMailVergessen->setAlphaFeldFarbe( 0x5500FF00 );
    eMailVergessen->setAlphaFeldStrength( -5 );
}

bool EMailVergessen::eMailVergessenME( void *obj, MausEreignis me ) // MausEreignis im Knopf eMailVergessen
{
    if( me.id == ME_RLinks )
    {
        vorLogin->setEMailVergessen();

        eMailVergessen->setRahmenBreite( 3 );
        eMailVergessen->setAlphaFeldFarbe( 0xFF000000 );
        eMailVergessen->setAlphaFeldStrength( 20 );
        Punkt bildschirmmitte = Bildschirmmitte();
        fenster->setSize( 255, 170 );
        fenster->setPosition( bildschirmmitte.x - 125, bildschirmmitte.y - 85 );
        fenster->addStyle( Fenster::Style::Sichtbar );
        nachricht->removeStyle( TextFeld::Style::Sichtbar );
        weiter->setText( "weiter" );
        weiter->setPosition( 75, 110 );
        name->addStyle( TextFeld::Style::Sichtbar );
        passwort->addStyle( TextFeld::Style::Sichtbar );
        geheimnis->addStyle( TextFeld::Style::Sichtbar );
        name->addStyle( TextFeld::Style::Fokus );
        name->setAuswahl( 0, name->zText()->getLength() );
    }
    return 1;
}

bool EMailVergessen::nameTE( void *obj, TastaturEreignis te ) // Tastaturereignis im Textfeld name
{
    if( te.id == TE_Press && te.taste == T_Enter )
        return 0;
    if( te.id == TE_Release && ( te.taste == T_Enter || te.taste == T_Tab ) )
    {
        name->removeStyle( TextFeld::Style::Fokus );
        passwort->addStyle( TextFeld::Style::Fokus );
        passwort->setAuswahl( 0, passwort->zText()->getLength() );
    }
    if( name->zText()->getLength() >= 25 && istSchreibbar( te.taste ) )
        return 0;
    return 1;
}

bool EMailVergessen::passwortTE( void *obj, TastaturEreignis te ) // Tastaturereignis im Textfeld passwort
{
    if( te.id == TE_Press && te.taste == T_Enter )
        return 0;
    if( te.id == TE_Press )
        passwort->setSchowChar( '*' );
    if( te.id == TE_Release && ( te.taste == T_Enter || te.taste == T_Tab ) )
    {
        passwort->removeStyle( TextFeld::Style::Fokus );
        geheimnis->addStyle( TextFeld::Style::Fokus );
        geheimnis->setAuswahl( 0, geheimnis->zText()->getLength() );
    }
    if( passwort->zText()->getLength() >= 25 && istSchreibbar( te.taste ) )
        return 0;
    return 1;
}

bool EMailVergessen::geheimnisTE( void *obj, TastaturEreignis te ) // Tastaturereignis im Textfeld geheimnis
{
    if( te.id == TE_Press && te.taste == T_Enter )
        return 0;
    if( te.id == TE_Press )
        geheimnis->setSchowChar( '*' );
    if( te.id == TE_Release && te.taste == T_Enter )
    {
        geheimnis->removeStyle( TextFeld::Style::Fokus );
        MausEreignis me;
        me.id = ME_RLinks;
        weiterME( 0, me );
    }
    if( geheimnis->zText()->getLength() >= 50 && istSchreibbar( te.taste ) )
        return 0;
    return 1;
}

bool EMailVergessen::weiterME( void *obj, MausEreignis me ) // MausEreignis im Knopf weiter
{
    if( me.id == ME_RLinks )
    {
        if( weiter->zText()->istGleich( "weiter" ) )
        {
            if( name->zText()->getLength() == 0 )
                zeigeNachricht( "Bitte gebe deinen Accountnamen ein." );
            if( passwort->zText()->getLength() == 0 )
                zeigeNachricht( "Bitte gebe dein Accountpasswort ein." );
            if( geheimnis->zText()->getLength() == 0 )
                zeigeNachricht( "Bitte gebe dein Accountgeheimnis ein." );
            if( weiter->zText()->istGleich( "Ok" ) )
                return 1;
            new AktionsThread( 9, name->zText()->getText(), passwort->zText()->getText(), geheimnis->zText()->getText(), 0, 0 );
        }
        else
        {
            Punkt bildschirmmitte = Bildschirmmitte();
            fenster->setSize( 255, 170 );
            fenster->setPosition( bildschirmmitte.x - 125, bildschirmmitte.y - 85 );
            fenster->addStyle( Fenster::Style::Sichtbar );
            nachricht->removeStyle( TextFeld::Style::Sichtbar );
            weiter->setText( "weiter" );
            weiter->setPosition( 75, 110 );
            name->addStyle( TextFeld::Style::Sichtbar );
            passwort->addStyle( TextFeld::Style::Sichtbar );
            geheimnis->addStyle( TextFeld::Style::Sichtbar );
            name->addStyle( TextFeld::Style::Fokus );
            name->setAuswahl( 0, name->zText()->getLength() );
        }
    }
    return 1;
}

void EMailVergessen::setReturn( bool ret, char *eMail ) // Setzt den Returnwert
{
    if( ret )
    {
        Text *nachricht = new Text( "Deine E-Mail Addresse lautet:'" );
        nachricht->append( eMail );
        nachricht->append( "'." );
        zeigeNachricht( nachricht->getText() );
        nachricht = nachricht->release();
    }
    else if( lastError.getLength() )
        zeigeNachricht( lastError );
    else
        zeigeNachricht( "Es ist ein Unbekannter Fehler aufgetreten." );
    delete eMail;
}

// Reference Counting
EMailVergessen *EMailVergessen::getThis()
{
    ref++;
    return this;
}

EMailVergessen *EMailVergessen::release()
{
    ref--;
    if( !ref )
        delete this;
    return 0;
}


// messages
bool eMailndernEMailndernME( void *p, void *obj, MausEreignis me )
{
    if( !p )
        return 0;
    return ( (EMailndern *)p )->eMailndernME( obj, me );
}

bool eMailndernNameTE( void *p, void *obj, TastaturEreignis te )
{
    if( !p )
        return 0;
    return ( (EMailndern *)p )->nameTE( obj, te );
}

bool eMailndernPasswortTE( void *p, void *obj, TastaturEreignis te )
{
    if( !p )
        return 0;
    return ( (EMailndern *)p )->passwortTE( obj, te );
}

bool eMailndernGeheimnisTE( void *p, void *obj, TastaturEreignis te )
{
    if( !p )
        return 0;
    return ( (EMailndern *)p )->geheimnisTE( obj, te );
}

bool eMailndernNEMailTE( void *p, void *obj, TastaturEreignis te )
{
    if( !p )
        return 0;
    return ( (EMailndern *)p )->nEMailTE( obj, te );
}

bool eMailndernWeiterME( void *p, void *obj, MausEreignis me )
{
    if( !p )
        return 0;
    return ( (EMailndern *)p )->weiterME( obj, me );
}


bool eMailVergessenEMailVergessenME( void *p, void *obj, MausEreignis me )
{
    if( !p )
        return 0;
    return ( (EMailVergessen *)p )->eMailVergessenME( obj, me );
}

bool eMailVergessenNameTE( void *p, void *obj, TastaturEreignis te )
{
    if( !p )
        return 0;
    return ( (EMailVergessen *)p )->nameTE( obj, te );
}

bool eMailVergessenPasswortTE( void *p, void *obj, TastaturEreignis te )
{
    if( !p )
        return 0;
    return ( (EMailVergessen *)p )->passwortTE( obj, te );
}

bool eMailVergessenGeheimnisTE( void *p, void *obj, TastaturEreignis te )
{
    if( !p )
        return 0;
    return ( (EMailVergessen *)p )->geheimnisTE( obj, te );
}

bool eMailVergessenWeiterME( void *p, void *obj, MausEreignis me )
{
    if( !p )
        return 0;
    return ( (EMailVergessen *)p )->weiterME( obj, me );
}