#ifndef EMail_H
#define EMail_H

#include <Knopf.h>
#include <Fenster.h>
#include <TextFeld.h>
#include <Schrift.h>
#include <Bildschirm.h>
#include "..\..\Aktionen\AktionsThread.h"

using namespace Framework;

class EMailndern
{
private:
	Knopf *eMailndern;
	Fenster *fenster;
	TextFeld *name;
	TextFeld *passwort;
	TextFeld *geheimnis;
	TextFeld *nEMail;
	Knopf *weiter;
	TextFeld *nachricht;
	int ref;
	void zeigeNachricht( const char *txt );

public:
	// Konstruktor
	EMailndern( Schrift *zSchrift, Fenster *zVorLoginFenster );
	// Destruktor
	~EMailndern();
	// Knopfdruck
	void druckFremdKnopf(); // Ein anderer Knopf wurde gedrckt
	bool eMailndernME( void *obj, MausEreignis me ); // MausEreignis im Knopf eMailndern
	bool nameTE( void *obj, TastaturEreignis te ); // Tastaturereignis im Textfeld name
	bool passwortTE( void *obj, TastaturEreignis te ); // Tastaturereignis im Textfeld passwort
	bool geheimnisTE( void *obj, TastaturEreignis te ); // Tastaturereignis im Textfeld geheimnis
	bool nEMailTE( void *obj, TastaturEreignis te ); // Tastaturereignis im Textfeld nEMail
	bool weiterME( void *obj, MausEreignis me ); // MausEreignis im Knopf weiter
	void setReturn( bool ret ); // Setzt den Returnwert
	// Reference Counting
	EMailndern *getThis();
	EMailndern *release();
};

class EMailVergessen
{
private:
	Knopf *eMailVergessen;
	Fenster *fenster;
	TextFeld *name;
	TextFeld *passwort;
	TextFeld *geheimnis;
	Knopf *weiter;
	TextFeld *nachricht;
	int ref;
	void zeigeNachricht( const char *txt );

public:
	// Konstruktor
	EMailVergessen( Schrift *zSchrift, Fenster *zVorLoginFenster );
	// Destruktor
	~EMailVergessen();
	// Knopfdruck
	void druckFremdKnopf(); // Ein anderer Knopf wurde gedrckt
	bool eMailVergessenME( void *obj, MausEreignis me ); // MausEreignis im Knopf eMailVergessen
	bool nameTE( void *obj, TastaturEreignis te ); // Tastaturereignis im Textfeld name
	bool passwortTE( void *obj, TastaturEreignis te ); // Tastaturereignis im Textfeld passwort
	bool geheimnisTE( void *obj, TastaturEreignis te ); // Tastaturereignis im Textfeld geheimnis
	bool weiterME( void *obj, MausEreignis me ); // MausEreignis im Knopf weiter
	void setReturn( bool ret, char *eMail ); // Setzt den Returnwert
	// Reference Counting
	EMailVergessen *getThis();
	EMailVergessen *release();
};

// messages
bool eMailndernEMailndernME( void *p, void *obj, MausEreignis me );
bool eMailndernNameTE( void *p, void *obj, TastaturEreignis te );
bool eMailndernPasswortTE( void *p, void *obj, TastaturEreignis te );
bool eMailndernGeheimnisTE( void *p, void *obj, TastaturEreignis te );
bool eMailndernNEMailTE( void *p, void *obj, TastaturEreignis te );
bool eMailndernWeiterME( void *p, void *obj, MausEreignis me );

bool eMailVergessenEMailVergessenME( void *p, void *obj, MausEreignis me );
bool eMailVergessenNameTE( void *p, void *obj, TastaturEreignis te );
bool eMailVergessenPasswortTE( void *p, void *obj, TastaturEreignis te );
bool eMailVergessenGeheimnisTE( void *p, void *obj, TastaturEreignis te );
bool eMailVergessenWeiterME( void *p, void *obj, MausEreignis me );

#endif