#include "..\..\Global\Variablen.h"
#include "Geheimnis.h"
#include "..\..\Global\Initialisierung.h"
#include <Punkt.h>
#include <Text.h>

// Inhalt der Geheimnisndern Klasse aus Geheimnis.h
// Konstruktor
Geheimnisndern::Geheimnisndern( Schrift *zSchrift, Fenster *zVorLoginFenster )
{
    Punkt bildschirmmitte = Bildschirmmitte();
    geheimnisndern = initKnopf( 10, 250, 130, 30, zSchrift, Knopf::Style::Sichtbar, "Geheimnis ndern" );
    geheimnisndern->setMausEreignisParameter( this );
    geheimnisndern->setMausEreignis( geheimnisndernGeheimnisndernME );
    initToolTip( geheimnisndern, "Account Geheimnis ndern.", zSchrift, hauptScreen );
    zVorLoginFenster->addMember( geheimnisndern->getThis() );
    fenster = initFenster( bildschirmmitte.x - 125, bildschirmmitte.y - 100, 250, 200, zSchrift, Fenster::Style::Erlaubt | Fenster::Style::Rahmen | Fenster::Style::Titel | Fenster::Style::TitelBuffered, "Geheimnis ndern" );
    name = initTextFeld( 20, 20, 208, 20, zSchrift, TextFeld::Style::TextFeld, "Name" );
    name->setTastaturEreignisParameter( this );
    name->setTastaturEreignis( geheimnisndernNameTE );
    initToolTip( name, "Account Name.", zSchrift, hauptScreen );
    fenster->addMember( name->getThis() );
    passwort = initTextFeld( 20, 50, 208, 20, zSchrift, TextFeld::Style::TextFeld, "Passwort" );
    passwort->setTastaturEreignisParameter( this );
    passwort->setTastaturEreignis( geheimnisndernPasswortTE );
    initToolTip( passwort, "Account Passwort.", zSchrift, hauptScreen );
    fenster->addMember( passwort->getThis() );
    geheimnis = initTextFeld( 20, 80, 208, 20, zSchrift, TextFeld::Style::TextFeld, "Geheimis" );
    geheimnis->setTastaturEreignisParameter( this );
    geheimnis->setTastaturEreignis( geheimnisndernGeheimnisTE );
    initToolTip( geheimnis, "Account Geheimni.", zSchrift, hauptScreen );
    fenster->addMember( geheimnis->getThis() );
    nGeheimnis = initTextFeld( 20, 110, 208, 20, zSchrift, TextFeld::Style::TextFeld, "neues Geheimnis" );
    nGeheimnis->setTastaturEreignisParameter( this );
    nGeheimnis->setTastaturEreignis( geheimnisndernNGeheimnisTE );
    initToolTip( nGeheimnis, "Neues Account Geheimnis.", zSchrift, hauptScreen );
    fenster->addMember( nGeheimnis->getThis() );
    weiter = initKnopf( 74, 140, 100, 20, zSchrift, Knopf::Style::Sichtbar, "weiter" );
    weiter->setMausEreignisParameter( this );
    weiter->setMausEreignis( geheimnisndernWeiterME );
    nachricht = initTextFeld( 0, 5, 255, 150, zSchrift, TextFeld::Style::HCenter | TextFeld::Style::Mehrzeilig, "" );
    fenster->addMember( nachricht->getThis() );
    fenster->addMember( weiter->getThis() );
    zVorLoginFenster->addMember( fenster->getThis() );
    ref = 1;
}

// Destruktor
Geheimnisndern::~Geheimnisndern()
{
    if( geheimnisndern )
        geheimnisndern = (Knopf *)geheimnisndern->release();
    if( fenster )
        fenster = (Fenster *)fenster->release();
    if( name )
        name = (TextFeld *)name->release();
    if( passwort )
        passwort = (TextFeld *)passwort->release();
    if( geheimnis )
        geheimnis = (TextFeld *)geheimnis->release();
    if( nGeheimnis )
        nGeheimnis = (TextFeld *)nGeheimnis->release();
    if( weiter )
        weiter = (Knopf *)weiter->release();
    if( nachricht )
        nachricht = (TextFeld *)nachricht->release();
}

// Privat
void Geheimnisndern::zeigeNachricht( const char *txt )
{
    Punkt bildschirmmitte = Bildschirmmitte();
    name->removeStyle( TextFeld::Style::Sichtbar );
    passwort->removeStyle( TextFeld::Style::Sichtbar );
    geheimnis->removeStyle( TextFeld::Style::Sichtbar );
    nGeheimnis->removeStyle( TextFeld::Style::Sichtbar );
    fenster->setSize( 250, 150 );
    fenster->setPosition( bildschirmmitte.x - 125, bildschirmmitte.y - 75 );
    weiter->setPosition( 139, 100 );
    weiter->setText( "Ok" );
    nachricht->setText( txt );
    if( nachricht->zText()->getLength() > 30 )
    {
        int pos = -1;
        bool set = 0;
        int lastp = 0;
        for( int i = 20; i < nachricht->zText()->getLength(); )
        {
            char *tmp = &nachricht->zText()->getText()[ i ];
            while( *tmp != ' ' && i < nachricht->zText()->getLength() )
            {
                tmp++;
                i++;
                if( i - 30 >= lastp )
                {
                    if( set )
                    {
                        lastp = pos;
                        set = 0;
                        nachricht->zText()->getText()[ pos ] = '\n';
                    }
                    else
                        lastp += 5;
                }
            }
            if( i < nachricht->zText()->getLength() )
            {
                pos = i;
                set = 1;
                tmp++;
                i++;
            }
        }
    }
    nachricht->addStyle( TextFeld::Style::Sichtbar );
}

// Knopfdruck
void Geheimnisndern::druckFremdKnopf() // Ein anderer Knopf wurde gedrckt
{
    fenster->removeStyle( Fenster::Style::Sichtbar );
    geheimnisndern->setRahmenBreite( 2 );
    geheimnisndern->setAlphaFeldFarbe( 0x5500FF00 );
    geheimnisndern->setAlphaFeldStrength( -5 );
}

bool Geheimnisndern::geheimnisndernME( void *obj, MausEreignis me ) // MausEreignis im Knopf geheimnisndern
{
    if( me.id == ME_RLinks )
    {
        vorLogin->setGeheimnisndern();

        geheimnisndern->setRahmenBreite( 3 );
        geheimnisndern->setAlphaFeldFarbe( 0xFF000000 );
        geheimnisndern->setAlphaFeldStrength( 20 );
        Punkt bildschirmmitte = Bildschirmmitte();
        fenster->setSize( 255, 200 );
        fenster->setPosition( bildschirmmitte.x - 125, bildschirmmitte.y - 100 );
        fenster->addStyle( Fenster::Style::Sichtbar );
        nachricht->removeStyle( TextFeld::Style::Sichtbar );
        weiter->setText( "weiter" );
        weiter->setPosition( 75, 140 );
        name->addStyle( TextFeld::Style::Sichtbar );
        passwort->addStyle( TextFeld::Style::Sichtbar );
        geheimnis->addStyle( TextFeld::Style::Sichtbar );
        nGeheimnis->addStyle( TextFeld::Style::Sichtbar );
        name->addStyle( TextFeld::Style::Fokus );
        name->setAuswahl( 0, name->zText()->getLength() );
    }
    return 1;
}

bool Geheimnisndern::nameTE( void *obj, TastaturEreignis te ) // Tastaturereignis im Textfeld name
{
    if( te.id == TE_Press && te.taste == T_Enter )
        return 0;
    if( te.id == TE_Release && ( te.taste == T_Enter || te.taste == T_Tab ) )
    {
        name->removeStyle( TextFeld::Style::Fokus );
        passwort->addStyle( TextFeld::Style::Fokus );
        passwort->setAuswahl( 0, passwort->zText()->getLength() );
    }
    if( name->zText()->getLength() >= 25 && istSchreibbar( te.taste ) )
        return 0;
    return 1;
}

bool Geheimnisndern::passwortTE( void *obj, TastaturEreignis te ) // Tastaturereignis im Textfeld passwort
{
    if( te.id == TE_Press && te.taste == T_Enter )
        return 0;
    if( te.id == TE_Press )
        passwort->setSchowChar( '*' );
    if( te.id == TE_Release && ( te.taste == T_Enter || te.taste == T_Tab ) )
    {
        passwort->removeStyle( TextFeld::Style::Fokus );
        geheimnis->addStyle( TextFeld::Style::Fokus );
        geheimnis->setAuswahl( 0, geheimnis->zText()->getLength() );
    }
    if( passwort->zText()->getLength() >= 25 && istSchreibbar( te.taste ) )
        return 0;
    return 1;
}

bool Geheimnisndern::geheimnisTE( void *obj, TastaturEreignis te ) // Tastaturereignis im Textfeld geheimnis
{
    if( te.id == TE_Press && te.taste == T_Enter )
        return 0;
    if( te.id == TE_Press )
        geheimnis->setSchowChar( '*' );
    if( te.id == TE_Release && ( te.taste == T_Enter || te.taste == T_Tab ) )
    {
        geheimnis->removeStyle( TextFeld::Style::Fokus );
        nGeheimnis->addStyle( TextFeld::Style::Fokus );
        nGeheimnis->setAuswahl( 0, nGeheimnis->zText()->getLength() );
    }
    if( geheimnis->zText()->getLength() >= 50 && istSchreibbar( te.taste ) )
        return 0;
    return 1;
}

bool Geheimnisndern::nGeheimnisTE( void *obj, TastaturEreignis te ) // Tastaturereignis im Textfeld nGeheimnis
{
    if( te.id == TE_Press && te.taste == T_Enter )
        return 0;
    if( te.id == TE_Release && te.taste == T_Enter )
    {
        nGeheimnis->removeStyle( TextFeld::Style::Fokus );
        MausEreignis me;
        me.id = ME_RLinks;
        weiterME( 0, me );
    }
    if( nGeheimnis->zText()->getLength() >= 25 && istSchreibbar( te.taste ) )
        return 0;
    return 1;
}

bool Geheimnisndern::weiterME( void *obj, MausEreignis me ) // MausEreignis im Knopf weiter
{
    if( me.id == ME_RLinks )
    {
        if( weiter->zText()->istGleich( "weiter" ) )
        {
            if( name->zText()->getLength() == 0 )
                zeigeNachricht( "Bitte gebe deinen Accountnamen ein." );
            if( passwort->zText()->getLength() == 0 )
                zeigeNachricht( "Bitte gebe dein Accountpasswort ein." );
            if( geheimnis->zText()->getLength() == 0 )
                zeigeNachricht( "Bitte gebe dein Accountgeheimnis ein." );
            if( nGeheimnis->zText()->getLength() == 0 )
                zeigeNachricht( "Bitte gebe ein neues Accountgeheimnis ein." );
            if( weiter->zText()->istGleich( "Ok" ) )
                return 1;
            new AktionsThread( 10, name->zText()->getText(), passwort->zText()->getText(), geheimnis->zText()->getText(), nGeheimnis->zText()->getText(), 0 );
        }
        else
        {
            Punkt bildschirmmitte = Bildschirmmitte();
            fenster->setSize( 255, 200 );
            fenster->setPosition( bildschirmmitte.x - 125, bildschirmmitte.y - 100 );
            fenster->addStyle( Fenster::Style::Sichtbar );
            nachricht->removeStyle( TextFeld::Style::Sichtbar );
            weiter->setText( "weiter" );
            weiter->setPosition( 75, 140 );
            name->addStyle( TextFeld::Style::Sichtbar );
            passwort->addStyle( TextFeld::Style::Sichtbar );
            geheimnis->addStyle( TextFeld::Style::Sichtbar );
            nGeheimnis->addStyle( TextFeld::Style::Sichtbar );
            name->addStyle( TextFeld::Style::Fokus );
            name->setAuswahl( 0, name->zText()->getLength() );
        }
    }
    return 1;
}

void Geheimnisndern::setResult( bool ret ) // Setzt den Returnwert
{
    if( ret )
        zeigeNachricht( "Geheimnis erfolgreich gendert." );
    else if( lastError.getLength() )
        zeigeNachricht( lastError );
    else
        zeigeNachricht( "Es ist ein Unbekannter Fehler aufgetreten." );
}

// Reference Counting
Geheimnisndern * Geheimnisndern::getThis()
{
    ref++;
    return 0;
}

Geheimnisndern *Geheimnisndern::release()
{
    ref--;
    if( !ref )
        delete this;
    return 0;
}


// Inhalt der GeheimnisVergessen Klasse aus Geheimnis.h
// Konstruktor
GeheimnisVergessen::GeheimnisVergessen( Schrift * zSchrift, Fenster * zVorLoginFenster )
{
    Punkt bildschirmmitte = Bildschirmmitte();
    geheimnisVergessen = initKnopf( 10, 370, 130, 30, zSchrift, Knopf::Style::Sichtbar, "Geheimnis vergessen" );
    geheimnisVergessen->setMausEreignisParameter( this );
    geheimnisVergessen->setMausEreignis( geheimnisVergessenGeheimnisVergessenME );
    initToolTip( geheimnisVergessen, "Account Geheimnis per E-Mail senden.", zSchrift, hauptScreen );
    zVorLoginFenster->addMember( geheimnisVergessen->getThis() );
    fenster = initFenster( bildschirmmitte.x - 125, bildschirmmitte.y - 70, 250, 140, zSchrift, Fenster::Style::Erlaubt | Fenster::Style::Rahmen | Fenster::Style::Titel | Fenster::Style::TitelBuffered, "Geheimnis vergessen" );
    name = initTextFeld( 20, 20, 208, 20, zSchrift, TextFeld::Style::TextFeld, "Name" );
    name->setTastaturEreignisParameter( this );
    name->setTastaturEreignis( geheimnisVergessenNameTE );
    initToolTip( name, "Account Name.", zSchrift, hauptScreen );
    fenster->addMember( name->getThis() );
    passwort = initTextFeld( 20, 50, 208, 20, zSchrift, TextFeld::Style::TextFeld, "Passwort" );
    passwort->setTastaturEreignisParameter( this );
    passwort->setTastaturEreignis( geheimnisVergessenPasswortTE );
    initToolTip( passwort, "Account Passwort.", zSchrift, hauptScreen );
    fenster->addMember( passwort->getThis() );
    weiter = initKnopf( 74, 80, 100, 20, zSchrift, Knopf::Style::Sichtbar, "weiter" );
    weiter->setMausEreignisParameter( this );
    weiter->setMausEreignis( geheimnisVergessenWeiterME );
    nachricht = initTextFeld( 0, 5, 255, 150, zSchrift, TextFeld::Style::HCenter | TextFeld::Style::Mehrzeilig, "" );
    fenster->addMember( nachricht->getThis() );
    fenster->addMember( weiter->getThis() );
    zVorLoginFenster->addMember( fenster->getThis() );
    ref = 1;
}

// Destruktor
GeheimnisVergessen::~GeheimnisVergessen()
{
    if( geheimnisVergessen )
        geheimnisVergessen = (Knopf *)geheimnisVergessen->release();
    if( fenster )
        fenster = (Fenster *)fenster->release();
    if( name )
        name = (TextFeld *)name->release();
    if( passwort )
        passwort = (TextFeld *)passwort->release();
    if( weiter )
        weiter = (Knopf *)weiter->release();
    if( nachricht )
        nachricht = (TextFeld *)nachricht->release();
}

// Privat
void GeheimnisVergessen::zeigeNachricht( const char *txt )
{
    Punkt bildschirmmitte = Bildschirmmitte();
    name->removeStyle( TextFeld::Style::Sichtbar );
    passwort->removeStyle( TextFeld::Style::Sichtbar );
    fenster->setSize( 250, 150 );
    fenster->setPosition( bildschirmmitte.x - 125, bildschirmmitte.y - 75 );
    weiter->setPosition( 139, 100 );
    weiter->setText( "Ok" );
    nachricht->setText( txt );
    if( nachricht->zText()->getLength() > 30 )
    {
        int pos = -1;
        bool set = 0;
        int lastp = 0;
        for( int i = 20; i < nachricht->zText()->getLength(); )
        {
            char *tmp = &nachricht->zText()->getText()[ i ];
            while( *tmp != ' ' && i < nachricht->zText()->getLength() )
            {
                tmp++;
                i++;
                if( i - 30 >= lastp )
                {
                    if( set )
                    {
                        lastp = pos;
                        set = 0;
                        nachricht->zText()->getText()[ pos ] = '\n';
                    }
                    else
                        lastp += 5;
                }
            }
            if( i < nachricht->zText()->getLength() )
            {
                pos = i;
                set = 1;
                tmp++;
                i++;
            }
        }
    }
    nachricht->addStyle( TextFeld::Style::Sichtbar );
}

// Knopfdruck
void GeheimnisVergessen::druckFremdKnopf() // Ein anderer Knopf wurde gedrckt
{
    fenster->removeStyle( Fenster::Style::Sichtbar );
    geheimnisVergessen->setRahmenBreite( 2 );
    geheimnisVergessen->setAlphaFeldFarbe( 0x5500FF00 );
    geheimnisVergessen->setAlphaFeldStrength( -5 );
}

bool GeheimnisVergessen::geheimnisVergessenME( void *obj, MausEreignis me ) // MausEreignis im Knopf geheimnisVergessen
{
    if( me.id == ME_RLinks )
    {
        vorLogin->setGeheilnisVergessen();

        geheimnisVergessen->setRahmenBreite( 3 );
        geheimnisVergessen->setAlphaFeldFarbe( 0xFF000000 );
        geheimnisVergessen->setAlphaFeldStrength( 20 );
        Punkt bildschirmmitte = Bildschirmmitte();
        fenster->setSize( 255, 140 );
        fenster->setPosition( bildschirmmitte.x - 125, bildschirmmitte.y - 70 );
        fenster->addStyle( Fenster::Style::Sichtbar );
        nachricht->removeStyle( TextFeld::Style::Sichtbar );
        weiter->setText( "weiter" );
        weiter->setPosition( 75, 80 );
        name->addStyle( TextFeld::Style::Sichtbar );
        passwort->addStyle( TextFeld::Style::Sichtbar );
        name->addStyle( TextFeld::Style::Fokus );
        name->setAuswahl( 0, name->zText()->getLength() );
    }
    return 1;
}

bool GeheimnisVergessen::nameTE( void *obj, TastaturEreignis te ) // Tastaturereignis im Textfeld name
{
    if( te.id == TE_Press && te.taste == T_Enter )
        return 0;
    if( te.id == TE_Release && ( te.taste == T_Enter || te.taste == T_Tab ) )
    {
        name->removeStyle( TextFeld::Style::Fokus );
        passwort->addStyle( TextFeld::Style::Fokus );
        passwort->setAuswahl( 0, passwort->zText()->getLength() );
    }
    if( name->zText()->getLength() >= 25 && istSchreibbar( te.taste ) )
        return 0;
    return 1;
}

bool GeheimnisVergessen::passwortTE( void *obj, TastaturEreignis te ) // Tastaturereignis im Textfeld passwort
{
    if( te.id == TE_Press && te.taste == T_Enter )
        return 0;
    if( te.id == TE_Press )
        passwort->setSchowChar( '*' );
    if( te.id == TE_Release && te.taste == T_Enter )
    {
        passwort->removeStyle( TextFeld::Style::Fokus );
        MausEreignis me;
        me.id = ME_RLinks;
        weiterME( 0, me );
    }
    if( passwort->zText()->getLength() >= 25 && istSchreibbar( te.taste ) )
        return 0;
    return 1;
}

bool GeheimnisVergessen::weiterME( void *obj, MausEreignis me ) // MausEreignis im Knopf weiter
{
    if( me.id == ME_RLinks )
    {
        if( weiter->zText()->istGleich( "weiter" ) )
        {
            if( name->zText()->getLength() == 0 )
                zeigeNachricht( "Bitte gebe deinen Accountnamen ein." );
            if( passwort->zText()->getLength() == 0 )
                zeigeNachricht( "Bitte gebe dein Accountpasswort ein." );
            if( weiter->zText()->istGleich( "Ok" ) )
                return 1;
            new AktionsThread( 11, name->zText()->getText(), passwort->zText()->getText(), 0, 0, 0 );
        }
        else
        {
            Punkt bildschirmmitte = Bildschirmmitte();
            fenster->setSize( 255, 140 );
            fenster->setPosition( bildschirmmitte.x - 125, bildschirmmitte.y - 70 );
            fenster->addStyle( Fenster::Style::Sichtbar );
            nachricht->removeStyle( TextFeld::Style::Sichtbar );
            weiter->setText( "weiter" );
            weiter->setPosition( 75, 80 );
            name->addStyle( TextFeld::Style::Sichtbar );
            passwort->addStyle( TextFeld::Style::Sichtbar );
            name->addStyle( TextFeld::Style::Fokus );
            name->setAuswahl( 0, name->zText()->getLength() );
        }
    }
    return 1;
}

void GeheimnisVergessen::setResult( bool ret ) // Setzt den Returnwert
{
    if( ret )
        zeigeNachricht( "Dir wurde eine E-Mail mit deinem Accountgeheimnis gesendet." );
    else if( lastError.getLength() )
        zeigeNachricht( lastError );
    else
        zeigeNachricht( "Es ist ein Unbekannter Fehler aufgetreten." );
}

// Reference Counting
GeheimnisVergessen * GeheimnisVergessen::getThis()
{
    ref++;
    return this;
}

GeheimnisVergessen *GeheimnisVergessen::release()
{
    ref--;
    if( !ref )
        delete this;
    return 0;
}


// messages
bool geheimnisndernGeheimnisndernME( void *p, void *obj, MausEreignis me )
{
    if( !p )
        return 0;
    return ( (Geheimnisndern *)p )->geheimnisndernME( obj, me );
}

bool geheimnisndernNameTE( void *p, void *obj, TastaturEreignis te )
{
    if( !p )
        return 0;
    return ( (Geheimnisndern *)p )->nameTE( obj, te );
}

bool geheimnisndernPasswortTE( void *p, void *obj, TastaturEreignis te )
{
    if( !p )
        return 0;
    return ( (Geheimnisndern *)p )->passwortTE( obj, te );
}

bool geheimnisndernGeheimnisTE( void *p, void *obj, TastaturEreignis te )
{
    if( !p )
        return 0;
    return ( (Geheimnisndern *)p )->geheimnisTE( obj, te );
}

bool geheimnisndernNGeheimnisTE( void *p, void *obj, TastaturEreignis te )
{
    if( !p )
        return 0;
    return ( (Geheimnisndern *)p )->nGeheimnisTE( obj, te );
}

bool geheimnisndernWeiterME( void *p, void *obj, MausEreignis me )
{
    if( !p )
        return 0;
    return ( (Geheimnisndern *)p )->weiterME( obj, me );
}


bool geheimnisVergessenGeheimnisVergessenME( void *p, void *obj, MausEreignis me )
{
    if( !p )
        return 0;
    return ( (GeheimnisVergessen *)p )->geheimnisVergessenME( obj, me );
}

bool geheimnisVergessenNameTE( void *p, void *obj, TastaturEreignis te )
{
    if( !p )
        return 0;
    return ( (GeheimnisVergessen *)p )->nameTE( obj, te );
}

bool geheimnisVergessenPasswortTE( void *p, void *obj, TastaturEreignis te )
{
    if( !p )
        return 0;
    return ( (GeheimnisVergessen *)p )->passwortTE( obj, te );
}

bool geheimnisVergessenWeiterME( void *p, void *obj, MausEreignis me )
{
    if( !p )
        return 0;
    return ( (GeheimnisVergessen *)p )->weiterME( obj, me );
}