#ifndef Geheimnis_H
#define Geheimnis_H

#include <Knopf.h>
#include <Fenster.h>
#include <TextFeld.h>
#include <Schrift.h>
#include <Bildschirm.h>
#include "..\..\Aktionen\AktionsThread.h"

using namespace Framework;

class Geheimnisndern
{
private:
	Knopf *geheimnisndern;
	Fenster *fenster;
	TextFeld *name;
	TextFeld *passwort;
	TextFeld *geheimnis;
	TextFeld *nGeheimnis;
	Knopf *weiter;
	TextFeld *nachricht;
	int ref;
	void zeigeNachricht( const char *txt );

public:
	// Konstruktor
	Geheimnisndern( Schrift *zSchrift, Fenster *zVorLoginFenster );
	// Destruktor
	~Geheimnisndern();
	// Knopfdruck
	void druckFremdKnopf(); // Ein anderer Knopf wurde gedrckt
	bool geheimnisndernME( void *obj, MausEreignis me ); // MausEreignis im Knopf geheimnisndern
	bool nameTE( void *obj, TastaturEreignis te ); // Tastaturereignis im Textfeld name
	bool passwortTE( void *obj, TastaturEreignis te ); // Tastaturereignis im Textfeld passwort
	bool geheimnisTE( void *obj, TastaturEreignis te ); // Tastaturereignis im Textfeld geheimnis
	bool nGeheimnisTE( void *obj, TastaturEreignis te ); // Tastaturereignis im Textfeld nGeheimnis
	bool weiterME( void *obj, MausEreignis me ); // MausEreignis im Knopf weiter
	void setResult( bool ret ); // Setzt den Returnwert
	// Reference Counting
	Geheimnisndern *getThis();
	Geheimnisndern *release();
};

class GeheimnisVergessen
{
private:
	Knopf *geheimnisVergessen;
	Fenster *fenster;
	TextFeld *name;
	TextFeld *passwort;
	Knopf *weiter;
	TextFeld *nachricht;
	int ref;
	void zeigeNachricht( const char *txt );

public:
	// Konstruktor
	GeheimnisVergessen( Schrift *zSchrift, Fenster *zVorLoginFenster );
	// Destruktor
	~GeheimnisVergessen();
	// Knopfdruck
	void druckFremdKnopf(); // Ein anderer Knopf wurde gedrckt
	bool geheimnisVergessenME( void *obj, MausEreignis me ); // MausEreignis im Knopf geheimnisVergessen
	bool nameTE( void *obj, TastaturEreignis te ); // Tastaturereignis im Textfeld name
	bool passwortTE( void *obj, TastaturEreignis te ); // Tastaturereignis im Textfeld passwort
	bool weiterME( void *obj, MausEreignis me ); // MausEreignis im Knopf weiter
	void setResult( bool ret ); // Setzt den Returnwert
	// Reference Counting
	GeheimnisVergessen *getThis();
	GeheimnisVergessen *release();
};

// messages
bool geheimnisndernGeheimnisndernME( void *p, void *obj, MausEreignis me );
bool geheimnisndernNameTE( void *p, void *obj, TastaturEreignis te );
bool geheimnisndernPasswortTE( void *p, void *obj, TastaturEreignis te );
bool geheimnisndernGeheimnisTE( void *p, void *obj, TastaturEreignis te );
bool geheimnisndernNGeheimnisTE( void *p, void *obj, TastaturEreignis te );
bool geheimnisndernWeiterME( void *p, void *obj, MausEreignis me );

bool geheimnisVergessenGeheimnisVergessenME( void *p, void *obj, MausEreignis me );
bool geheimnisVergessenNameTE( void *p, void *obj, TastaturEreignis te );
bool geheimnisVergessenPasswortTE( void *p, void *obj, TastaturEreignis te );
bool geheimnisVergessenWeiterME( void *p, void *obj, MausEreignis me );

#endif