#include "..\..\Global\Variablen.h"
#include "Passwort.h"
#include "..\..\Global\Initialisierung.h"
#include <Punkt.h>
#include <Text.h>

// Inhalt der Passwortndern Klasse aus Passwort.h
// Konstruktor
Passwortndern::Passwortndern( Schrift *zSchrift, Fenster *zVorLoginFenster )
{
    Punkt bildschirmmitte = Bildschirmmitte();
    passwortndern = initKnopf( 10, 170, 130, 30, zSchrift, Knopf::Style::Sichtbar, "Passwort ndern" );
    passwortndern->setMausEreignisParameter( this );
    passwortndern->setMausEreignis( passwortndernPasswortndernME );
    initToolTip( passwortndern, "Account Passwort ndern.", zSchrift, hauptScreen );
    zVorLoginFenster->addMember( passwortndern->getThis() );
    fenster = initFenster( bildschirmmitte.x - 125, bildschirmmitte.y - 115, 250, 230, zSchrift, Fenster::Style::Erlaubt | Fenster::Style::Rahmen | Fenster::Style::Titel | Fenster::Style::TitelBuffered, "Passwort ndern" );
    name = initTextFeld( 20, 20, 208, 20, zSchrift, TextFeld::Style::TextFeld, "Name" );
    name->setTastaturEreignisParameter( this );
    name->setTastaturEreignis( passwortndernNameTE );
    initToolTip( name, "Account Name.", zSchrift, hauptScreen );
    fenster->addMember( name->getThis() );
    passwort = initTextFeld( 20, 50, 208, 20, zSchrift, TextFeld::Style::TextFeld, "Passwort" );
    passwort->setTastaturEreignisParameter( this );
    passwort->setTastaturEreignis( passwortndernPasswortTE );
    initToolTip( passwort, "Account Passwort.", zSchrift, hauptScreen );
    fenster->addMember( passwort->getThis() );
    neuPasswort = initTextFeld( 20, 80, 208, 20, zSchrift, TextFeld::Style::TextFeld, "neues Passwort" );
    neuPasswort->setTastaturEreignisParameter( this );
    neuPasswort->setTastaturEreignis( passwortndernNeuPasswortTE );
    initToolTip( neuPasswort, "Neues Account Passwort.", zSchrift, hauptScreen );
    fenster->addMember( neuPasswort->getThis() );
    neuPasswort2 = initTextFeld( 20, 110, 208, 20, zSchrift, TextFeld::Style::TextFeld, "Passwort wiederholen" );
    neuPasswort2->setTastaturEreignisParameter( this );
    neuPasswort2->setTastaturEreignis( passwortndernNeuPasswort2TE );
    initToolTip( neuPasswort2, "Neues Passwort Wiederhohlen.", zSchrift, hauptScreen );
    fenster->addMember( neuPasswort2->getThis() );
    geheimnis = initTextFeld( 20, 140, 208, 20, zSchrift, TextFeld::Style::TextFeld, "Geheimis" );
    geheimnis->setTastaturEreignisParameter( this );
    geheimnis->setTastaturEreignis( passwortndernGeheimnisTE );
    initToolTip( geheimnis, "Account Geheimnis.", zSchrift, hauptScreen );
    fenster->addMember( geheimnis->getThis() );
    weiter = initKnopf( 74, 170, 100, 20, zSchrift, Knopf::Style::Sichtbar, "weiter" );
    weiter->setMausEreignisParameter( this );
    weiter->setMausEreignis( passwortndernWeiterME );
    nachricht = initTextFeld( 0, 5, 255, 150, zSchrift, TextFeld::Style::HCenter | TextFeld::Style::Mehrzeilig, "" );
    fenster->addMember( nachricht->getThis() );
    fenster->addMember( weiter->getThis() );
    zVorLoginFenster->addMember( fenster->getThis() );
    ref = 1;
}

// Destruktor
Passwortndern::~Passwortndern()
{
    if( passwortndern )
        passwortndern = (Knopf *)passwortndern->release();
    if( fenster )
        fenster = (Fenster *)fenster->release();
    if( name )
        name = (TextFeld *)name->release();
    if( passwort )
        passwort = (TextFeld *)passwort->release();
    if( neuPasswort )
        neuPasswort = (TextFeld *)neuPasswort->release();
    if( neuPasswort2 )
        neuPasswort2 = (TextFeld *)neuPasswort2->release();
    if( geheimnis )
        geheimnis = (TextFeld *)geheimnis->release();
    if( weiter )
        weiter = (Knopf *)weiter->release();
    if( nachricht )
        nachricht = (TextFeld *)nachricht->release();
}

// Privat
void Passwortndern::zeigeNachricht( const char *txt )
{
    Punkt bildschirmmitte = Bildschirmmitte();
    name->removeStyle( TextFeld::Style::Sichtbar );
    passwort->removeStyle( TextFeld::Style::Sichtbar );
    neuPasswort->removeStyle( TextFeld::Style::Sichtbar );
    neuPasswort2->removeStyle( TextFeld::Style::Sichtbar );
    geheimnis->removeStyle( TextFeld::Style::Sichtbar );
    fenster->setSize( 250, 150 );
    fenster->setPosition( bildschirmmitte.x - 125, bildschirmmitte.y - 75 );
    weiter->setPosition( 139, 100 );
    weiter->setText( "Ok" );
    nachricht->setText( txt );
    if( nachricht->zText()->getLength() > 30 )
    {
        int pos = -1;
        bool set = 0;
        int lastp = 0;
        for( int i = 20; i < nachricht->zText()->getLength(); )
        {
            char *tmp = &nachricht->zText()->getText()[ i ];
            while( *tmp != ' ' && i < nachricht->zText()->getLength() )
            {
                tmp++;
                i++;
                if( i - 30 >= lastp )
                {
                    if( set )
                    {
                        lastp = pos;
                        set = 0;
                        nachricht->zText()->getText()[ pos ] = '\n';
                    }
                    else
                        lastp += 5;
                }
            }
            if( i < nachricht->zText()->getLength() )
            {
                pos = i;
                set = 1;
                tmp++;
                i++;
            }
        }
    }
    nachricht->addStyle( TextFeld::Style::Sichtbar );
}

// Knopfdruck
void Passwortndern::druckFremdKnopf() // Ein anderer Knopf wurde gedrckt
{
    fenster->removeStyle( Fenster::Style::Sichtbar );
    passwortndern->setRahmenBreite( 2 );
    passwortndern->setAlphaFeldFarbe( 0x5500FF00 );
    passwortndern->setAlphaFeldStrength( -5 );
}

bool Passwortndern::passwortndernME( void *obj, MausEreignis me ) // MausEreignis im Knopf passwortVergessen
{
    if( me.id == ME_RLinks )
    {
        vorLogin->setPasswortndern();

        passwortndern->setRahmenBreite( 3 );
        passwortndern->setAlphaFeldFarbe( 0xFF000000 );
        passwortndern->setAlphaFeldStrength( 20 );
        Punkt bildschirmmitte = Bildschirmmitte();
        fenster->setSize( 255, 230 );
        fenster->setPosition( bildschirmmitte.x - 125, bildschirmmitte.y - 115 );
        fenster->addStyle( Fenster::Style::Sichtbar );
        nachricht->removeStyle( TextFeld::Style::Sichtbar );
        weiter->setText( "weiter" );
        weiter->setPosition( 75, 170 );
        name->addStyle( TextFeld::Style::Sichtbar );
        passwort->addStyle( TextFeld::Style::Sichtbar );
        neuPasswort->addStyle( TextFeld::Style::Sichtbar );
        neuPasswort2->addStyle( TextFeld::Style::Sichtbar );
        geheimnis->addStyle( TextFeld::Style::Sichtbar );
        name->addStyle( TextFeld::Style::Fokus );
        name->setAuswahl( 0, name->zText()->getLength() );
    }
    return 1;
}

bool Passwortndern::nameTE( void *obj, TastaturEreignis te ) // Tastaturereignis im Textfeld name
{
    if( te.id == TE_Press && te.taste == T_Enter )
        return 0;
    if( te.id == TE_Release && ( te.taste == T_Enter || te.taste == T_Tab ) )
    {
        name->removeStyle( TextFeld::Style::Fokus );
        passwort->addStyle( TextFeld::Style::Fokus );
        passwort->setAuswahl( 0, passwort->zText()->getLength() );
    }
    if( name->zText()->getLength() >= 25 && istSchreibbar( te.taste ) )
        return 0;
    return 1;
}

bool Passwortndern::passwortTE( void *obj, TastaturEreignis te ) // Tastaturereignis im Textfeld passwort
{
    if( te.id == TE_Press && te.taste == T_Enter )
        return 0;
    if( te.id == TE_Press )
        passwort->setSchowChar( '*' );
    if( te.id == TE_Release && ( te.taste == T_Enter || te.taste == T_Tab ) )
    {
        passwort->removeStyle( TextFeld::Style::Fokus );
        neuPasswort->addStyle( TextFeld::Style::Fokus );
        neuPasswort->setAuswahl( 0, neuPasswort->zText()->getLength() );
    }
    if( passwort->zText()->getLength() >= 25 && istSchreibbar( te.taste ) )
        return 0;
    return 1;
}

bool Passwortndern::neuPasswortTE( void *obj, TastaturEreignis te ) // Tastaturereignis im Textfeld neuPasswort
{
    if( te.id == TE_Press && te.taste == T_Enter )
        return 0;
    if( te.id == TE_Press )
        neuPasswort->setSchowChar( '*' );
    if( te.id == TE_Release && ( te.taste == T_Enter || te.taste == T_Tab ) )
    {
        neuPasswort->removeStyle( TextFeld::Style::Fokus );
        neuPasswort2->addStyle( TextFeld::Style::Fokus );
        neuPasswort2->setAuswahl( 0, neuPasswort2->zText()->getLength() );
    }
    if( neuPasswort->zText()->getLength() >= 25 && istSchreibbar( te.taste ) )
        return 0;
    return 1;
}

bool Passwortndern::neuPasswort2TE( void *obj, TastaturEreignis te ) // Tastaturereignis im Textfeld neuPasswort2
{
    if( te.id == TE_Press && te.taste == T_Enter )
        return 0;
    if( te.id == TE_Press )
        neuPasswort2->setSchowChar( '*' );
    if( te.id == TE_Release && ( te.taste == T_Enter || te.taste == T_Tab ) )
    {
        neuPasswort2->removeStyle( TextFeld::Style::Fokus );
        geheimnis->addStyle( TextFeld::Style::Fokus );
        geheimnis->setAuswahl( 0, geheimnis->zText()->getLength() );
    }
    if( neuPasswort2->zText()->getLength() >= 25 && istSchreibbar( te.taste ) )
        return 0;
    return 1;
}

bool Passwortndern::geheimnisTE( void *obj, TastaturEreignis te ) // Tastaturereignis im Textfeld geheimnis
{
    if( te.id == TE_Press && te.taste == T_Enter )
        return 0;
    if( te.id == TE_Press )
        geheimnis->setSchowChar( '*' );
    if( te.id == TE_Release && te.taste == T_Enter )
    {
        geheimnis->removeStyle( TextFeld::Style::Fokus );
        MausEreignis me;
        me.id = ME_RLinks;
        weiterME( 0, me );
    }
    if( geheimnis->zText()->getLength() >= 50 && istSchreibbar( te.taste ) )
        return 0;
    return 1;
}

bool Passwortndern::weiterME( void *obj, MausEreignis me ) // MausEreignis im Knopf weiter
{
    if( me.id == ME_RLinks )
    {
        if( weiter->zText()->istGleich( "weiter" ) )
        {
            if( name->zText()->getLength() == 0 )
                zeigeNachricht( "Bitte gebe deinen Accountnamen ein." );
            if( passwort->zText()->getLength() == 0 )
                zeigeNachricht( "Bitte gebe dein Accountpasswort ein." );
            if( neuPasswort->zText()->getLength() == 0 )
                zeigeNachricht( "Bitte gebe ein neues Passwort ein." );
            if( geheimnis->zText()->getLength() == 0 )
                zeigeNachricht( "Bitte gebe dein Accountgeheimnis ein." );
            if( !neuPasswort2->zText()->istGleich( neuPasswort->zText()->getText() ) )
                zeigeNachricht( "Das wiederhohlte Passwort stimmt nicht mit dem neuen Passwort berein." );
            if( weiter->zText()->istGleich( "Ok" ) )
                return 1;
            new AktionsThread( 13, name->zText()->getText(), passwort->zText()->getText(), geheimnis->zText()->getText(), neuPasswort->zText()->getText(), 0 );
        }
        else
        {
            Punkt bildschirmmitte = Bildschirmmitte();
            fenster->setSize( 255, 230 );
            fenster->setPosition( bildschirmmitte.x - 125, bildschirmmitte.y - 115 );
            fenster->addStyle( Fenster::Style::Sichtbar );
            nachricht->removeStyle( TextFeld::Style::Sichtbar );
            weiter->setText( "weiter" );
            weiter->setPosition( 75, 170 );
            name->addStyle( TextFeld::Style::Sichtbar );
            passwort->addStyle( TextFeld::Style::Sichtbar );
            neuPasswort->addStyle( TextFeld::Style::Sichtbar );
            neuPasswort2->addStyle( TextFeld::Style::Sichtbar );
            geheimnis->addStyle( TextFeld::Style::Sichtbar );
            name->addStyle( TextFeld::Style::Fokus );
            name->setAuswahl( 0, name->zText()->getLength() );
        }
    }
    return 1;
}

void Passwortndern::setResult( bool ret ) // Setzt den Returnwert
{
    if( ret )
        zeigeNachricht( "Passwort erfolgreich gendert." );
    else if( lastError.getLength() )
        zeigeNachricht( lastError );
    else
        zeigeNachricht( "Es ist ein Unbekannter Fehler aufgetreten." );
}

// Reference Counting
Passwortndern * Passwortndern::getThis()
{
    ref++;
    return this;
}

Passwortndern *Passwortndern::release()
{
    ref--;
    if( !ref )
        delete this;
    return 0;
}


// Inhalt der PasswortVergessen Klasse aus Passwort.h
// Konstruktor
PasswortVergessen::PasswortVergessen( Schrift * zSchrift, Fenster * zVorLoginFenster )
{
    Punkt bildschirmmitte = Bildschirmmitte();
    passwortVergessen = initKnopf( 10, 330, 130, 30, zSchrift, Knopf::Style::Sichtbar, "Passwort vergessen" );
    passwortVergessen->setMausEreignisParameter( this );
    passwortVergessen->setMausEreignis( passwortVergessenPasswortVergessenME );
    initToolTip( passwortVergessen, "Account Passwort per E-Mail senden.", zSchrift, hauptScreen );
    zVorLoginFenster->addMember( passwortVergessen->getThis() );
    fenster = initFenster( bildschirmmitte.x - 125, bildschirmmitte.y - 70, 250, 140, zSchrift, Fenster::Style::Erlaubt | Fenster::Style::Rahmen | Fenster::Style::Titel | Fenster::Style::TitelBuffered, "Passwort vergessen" );
    name = initTextFeld( 20, 20, 208, 20, zSchrift, TextFeld::Style::TextFeld, "Name" );
    name->setTastaturEreignisParameter( this );
    name->setTastaturEreignis( passwortVergessenNameTE );
    initToolTip( name, "Account Name.", zSchrift, hauptScreen );
    fenster->addMember( name->getThis() );
    geheimnis = initTextFeld( 20, 50, 208, 20, zSchrift, TextFeld::Style::TextFeld, "Geheimis" );
    geheimnis->setTastaturEreignisParameter( this );
    geheimnis->setTastaturEreignis( passwortVergessenGeheimnisTE );
    initToolTip( geheimnis, "Account geheimnis.", zSchrift, hauptScreen );
    fenster->addMember( geheimnis->getThis() );
    weiter = initKnopf( 74, 80, 100, 20, zSchrift, Knopf::Style::Sichtbar, "weiter" );
    weiter->setMausEreignisParameter( this );
    weiter->setMausEreignis( passwortVergessenWeiterME );
    nachricht = initTextFeld( 0, 5, 255, 150, zSchrift, TextFeld::Style::HCenter | TextFeld::Style::Mehrzeilig, "" );
    fenster->addMember( nachricht->getThis() );
    fenster->addMember( weiter->getThis() );
    zVorLoginFenster->addMember( fenster->getThis() );
    ref = 1;
}

// Destruktor
PasswortVergessen::~PasswortVergessen()
{
    if( passwortVergessen )
        passwortVergessen = (Knopf *)passwortVergessen->release();
    if( fenster )
        fenster = (Fenster *)fenster->release();
    if( name )
        name = (TextFeld *)name->release();
    if( geheimnis )
        geheimnis = (TextFeld *)geheimnis->release();
    if( weiter )
        weiter = (Knopf *)weiter->release();
    if( nachricht )
        nachricht = (TextFeld *)nachricht->release();
}

// Privat
void PasswortVergessen::zeigeNachricht( const char *txt )
{
    Punkt bildschirmmitte = Bildschirmmitte();
    name->removeStyle( TextFeld::Style::Sichtbar );
    geheimnis->removeStyle( TextFeld::Style::Sichtbar );
    fenster->setSize( 250, 150 );
    fenster->setPosition( bildschirmmitte.x - 125, bildschirmmitte.y - 75 );
    weiter->setPosition( 139, 100 );
    weiter->setText( "Ok" );
    nachricht->setText( txt );
    if( nachricht->zText()->getLength() > 30 )
    {
        int pos = -1;
        bool set = 0;
        int lastp = 0;
        for( int i = 20; i < nachricht->zText()->getLength(); )
        {
            char *tmp = &nachricht->zText()->getText()[ i ];
            while( *tmp != ' ' && i < nachricht->zText()->getLength() )
            {
                tmp++;
                i++;
                if( i - 30 >= lastp )
                {
                    if( set )
                    {
                        lastp = pos;
                        set = 0;
                        nachricht->zText()->getText()[ pos ] = '\n';
                    }
                    else
                        lastp += 5;
                }
            }
            if( i < nachricht->zText()->getLength() )
            {
                pos = i;
                set = 1;
                tmp++;
                i++;
            }
        }
    }
    nachricht->addStyle( TextFeld::Style::Sichtbar );
}

// Knopfdruck
void PasswortVergessen::druckFremdKnopf() // Ein anderer Knopf wurde gedrckt
{
    fenster->removeStyle( Fenster::Style::Sichtbar );
    passwortVergessen->setRahmenBreite( 2 );
    passwortVergessen->setAlphaFeldFarbe( 0x5500FF00 );
    passwortVergessen->setAlphaFeldStrength( -5 );
}

bool PasswortVergessen::passwortVergessenME( void *obj, MausEreignis me ) // MausEreignis im Knopf passwortVergessen
{
    if( me.id == ME_RLinks )
    {
        vorLogin->setPasswortVergessen();

        passwortVergessen->setRahmenBreite( 3 );
        passwortVergessen->setAlphaFeldFarbe( 0xFF000000 );
        passwortVergessen->setAlphaFeldStrength( 20 );
        Punkt bildschirmmitte = Bildschirmmitte();
        fenster->setSize( 255, 140 );
        fenster->setPosition( bildschirmmitte.x - 125, bildschirmmitte.y - 70 );
        fenster->addStyle( Fenster::Style::Sichtbar );
        nachricht->removeStyle( TextFeld::Style::Sichtbar );
        weiter->setText( "weiter" );
        weiter->setPosition( 75, 80 );
        name->addStyle( TextFeld::Style::Sichtbar );
        geheimnis->addStyle( TextFeld::Style::Sichtbar );
        name->addStyle( TextFeld::Style::Fokus );
        name->setAuswahl( 0, name->zText()->getLength() );
    }
    return 1;
}

bool PasswortVergessen::nameTE( void *obj, TastaturEreignis te ) // Tastaturereignis im Textfeld name
{
    if( te.id == TE_Press && te.taste == T_Enter )
        return 0;
    if( te.id == TE_Release && ( te.taste == T_Enter || te.taste == T_Tab ) )
    {
        name->removeStyle( TextFeld::Style::Fokus );
        geheimnis->addStyle( TextFeld::Style::Fokus );
        geheimnis->setAuswahl( 0, geheimnis->zText()->getLength() );
    }
    if( name->zText()->getLength() >= 25 && istSchreibbar( te.taste ) )
        return 0;
    return 1;
}

bool PasswortVergessen::geheimnisTE( void *obj, TastaturEreignis te ) // Tastaturereignis im Textfeld geheimnis
{
    if( te.id == TE_Press && te.taste == T_Enter )
        return 0;
    if( te.id == TE_Press )
        geheimnis->setSchowChar( '*' );
    if( te.id == TE_Release && te.taste == T_Enter )
    {
        geheimnis->removeStyle( TextFeld::Style::Fokus );
        MausEreignis me;
        me.id = ME_RLinks;
        weiterME( 0, me );
    }
    if( geheimnis->zText()->getLength() >= 50 && istSchreibbar( te.taste ) )
        return 0;
    return 1;
}

bool PasswortVergessen::weiterME( void *obj, MausEreignis me ) // MausEreignis im Knopf weiter
{
    if( me.id == ME_RLinks )
    {
        if( weiter->zText()->istGleich( "weiter" ) )
        {
            if( name->zText()->getLength() == 0 )
                zeigeNachricht( "Bitte gebe deinen Accountnamen ein." );
            if( geheimnis->zText()->getLength() == 0 )
                zeigeNachricht( "Bitte gebe dein Accountgeheimnis ein." );
            if( weiter->zText()->istGleich( "Ok" ) )
                return 1;
            new AktionsThread( 14, name->zText()->getText(), geheimnis->zText()->getText(), 0, 0, 0 );
        }
        else
        {
            Punkt bildschirmmitte = Bildschirmmitte();
            fenster->setSize( 255, 140 );
            fenster->setPosition( bildschirmmitte.x - 125, bildschirmmitte.y - 70 );
            fenster->addStyle( Fenster::Style::Sichtbar );
            nachricht->removeStyle( TextFeld::Style::Sichtbar );
            weiter->setText( "weiter" );
            weiter->setPosition( 75, 80 );
            name->addStyle( TextFeld::Style::Sichtbar );
            geheimnis->addStyle( TextFeld::Style::Sichtbar );
            name->addStyle( TextFeld::Style::Fokus );
            name->setAuswahl( 0, name->zText()->getLength() );
        }
    }
    return 1;
}

void PasswortVergessen::setResult( bool ret ) // Setzt den Returnwert
{
    if( ret )
        zeigeNachricht( "Dir wurde eine E-Mail mit deinem Accountpasswort gesendet." );
    else if( lastError.getLength() )
        zeigeNachricht( lastError );
    else
        zeigeNachricht( "Es ist ein Unbekannter Fehler aufgetreten." );
}

// Reference Counting
PasswortVergessen * PasswortVergessen::getThis()
{
    ref++;
    return this;
}

PasswortVergessen *PasswortVergessen::release()
{
    ref--;
    if( !ref )
        delete this;
    return 0;
}

// messages
bool passwortndernPasswortndernME( void *p, void *obj, MausEreignis me )
{
    if( !p )
        return 0;
    return ( (Passwortndern *)p )->passwortndernME( obj, me );
}

bool passwortndernNameTE( void *p, void *obj, TastaturEreignis te )
{
    if( !p )
        return 0;
    return ( (Passwortndern *)p )->nameTE( obj, te );
}

bool passwortndernPasswortTE( void *p, void *obj, TastaturEreignis te )
{
    if( !p )
        return 0;
    return ( (Passwortndern *)p )->passwortTE( obj, te );
}

bool passwortndernNeuPasswortTE( void *p, void *obj, TastaturEreignis te )
{
    if( !p )
        return 0;
    return ( (Passwortndern *)p )->neuPasswortTE( obj, te );
}

bool passwortndernNeuPasswort2TE( void *p, void *obj, TastaturEreignis te )
{
    if( !p )
        return 0;
    return ( (Passwortndern *)p )->neuPasswort2TE( obj, te );
}

bool passwortndernGeheimnisTE( void *p, void *obj, TastaturEreignis te )
{
    if( !p )
        return 0;
    return ( (Passwortndern *)p )->geheimnisTE( obj, te );
}

bool passwortndernWeiterME( void *p, void *obj, MausEreignis me )
{
    if( !p )
        return 0;
    return ( (Passwortndern *)p )->weiterME( obj, me );
}


bool passwortVergessenPasswortVergessenME( void *p, void *obj, MausEreignis me )
{
    if( !p )
        return 0;
    return ( (PasswortVergessen *)p )->passwortVergessenME( obj, me );
}

bool passwortVergessenNameTE( void *p, void *obj, TastaturEreignis te )
{
    if( !p )
        return 0;
    return ( (PasswortVergessen *)p )->nameTE( obj, te );
}

bool passwortVergessenGeheimnisTE( void *p, void *obj, TastaturEreignis te )
{
    if( !p )
        return 0;
    return ( (PasswortVergessen *)p )->geheimnisTE( obj, te );
}

bool passwortVergessenWeiterME( void *p, void *obj, MausEreignis me )
{
    if( !p )
        return 0;
    return ( (PasswortVergessen *)p )->weiterME( obj, me );
}