#include "..\..\Global\Variablen.h"
#include "..\..\Global\Initialisierung.h"
#include "Registrierung.h"
#include <Punkt.h>
#include <Text.h>
#include <Zeit.h>

// Inhalt der Registrierung Klasse aus Registrierung.h
// Konstruktor 
Registrierung::Registrierung( Schrift *zSchrift, Fenster *zVorLoginFenster )
{
    Punkt bildschirmGre = BildschirmGre();
    registrierung = initKnopf( 10, 90, 130, 30, zSchrift, Knopf::Style::Sichtbar, "Registrieren" );
    registrierung->setMausEreignisParameter( this );
    registrierung->setMausEreignis( registrierungRegistrierungME );
    initToolTip( registrierung, "Account erstellen.", zSchrift, hauptScreen );
    zVorLoginFenster->addMember( registrierung->getThis() );
    fenster = initFenster( bildschirmGre.x / 2 - 175, bildschirmGre.y / 2 - 131, 350, 262, zSchrift, Fenster::Style::Erlaubt | Fenster::Style::Rahmen | Fenster::Style::Titel | Fenster::Style::TitelBuffered, "Account erstellen" );
    name = initTextFeld( 74, 20, 200, 20, zSchrift, TextFeld::Style::TextFeld, "Account Name" );
    name->setTastaturEreignisParameter( this );
    name->setTastaturEreignis( registrierungNameTE );
    initToolTip( name, "Account Name.", zSchrift, hauptScreen );
    fenster->addMember( name->getThis() );
    passwort = initTextFeld( 74, 50, 200, 20, zSchrift, TextFeld::Style::TextFeld, "Account Passwort" );
    passwort->setTastaturEreignisParameter( this );
    passwort->setTastaturEreignis( registrierungPasswortTE );
    initToolTip( passwort, "Account Passwort.", zSchrift, hauptScreen );
    fenster->addMember( passwort->getThis() );
    passwort2 = initTextFeld( 74, 80, 200, 20, zSchrift, TextFeld::Style::TextFeld, "Passwort wiederholen" );
    passwort2->setTastaturEreignisParameter( this );
    passwort2->setTastaturEreignis( registrierungPasswort2TE );
    initToolTip( passwort2, "Account Passwort wiederhohlen.", zSchrift, hauptScreen );
    fenster->addMember( passwort2->getThis() );
    geheimnis = initTextFeld( 10, 110, 328, 20, zSchrift, TextFeld::Style::TextFeld, "Account Geheimnis" );
    geheimnis->setTastaturEreignisParameter( this );
    geheimnis->setTastaturEreignis( registrierungGeheimnisTE );
    initToolTip( geheimnis, "Gib etwas ein, was nur du jederzeit weit.\n(zweites sicherheitspasswort Passwort)", zSchrift, hauptScreen );
    fenster->addMember( geheimnis->getThis() );
    eMail = initTextFeld( 74, 140, 200, 20, zSchrift, TextFeld::Style::TextFeld, "E-Mail Addresse" );
    eMail->setTastaturEreignisParameter( this );
    eMail->setTastaturEreignis( registrierungEMailTE );
    initToolTip( eMail, "E-Mail Addresse.", zSchrift, hauptScreen );
    fenster->addMember( eMail->getThis() );
    geburtsdatum = initTextFeld( 40, 170, 85, 20, zSchrift, TextFeld::Style::Text, "Geburtsdatum:" );
    fenster->addMember( geburtsdatum->getThis() );
    text = initTextFeld( 0, 5, 250, 150, zSchrift, TextFeld::Style::Mehrzeilig | TextFeld::Style::HCenter, "" );
    fenster->addMember( text->getThis() );
    gbdTag = new AuswahlBox();
    gbdTag->setStyle( AuswahlBox::Style::Sichtbar | AuswahlBox::Style::Erlaubt | AuswahlBox::Style::Rahmen | AuswahlBox::Style::MausBuffer | AuswahlBox::Style::AuswahlBuffer | AuswahlBox::Style::MaxHeight | AuswahlBox::Style::VScroll | AuswahlBox::Style::Hintergrund );
    gbdTag->setPosition( 130, 167 );
    gbdTag->setSize( 50, 20 );
    gbdTag->setMaxAuskappHeight( 100 );
    gbdTag->setSchriftZ( zSchrift->getThis() );
    gbdTag->setRahmenFarbe( 0xFFFFFFFF );
    gbdTag->setHintergrundFarbe( 0xFF000000 );
    gbdTag->setMausEreignis( _ret1ME );
    gbdTag->addEintrag( "Tag" );
    for( int i = 0; i < 31; i++ )
    {
        Text *txt = new Text( "" );
        txt->append( i + 1 );
        gbdTag->addEintrag( txt );
    }
    gbdMonat = new AuswahlBox();
    gbdMonat->setStyle( AuswahlBox::Style::Sichtbar | AuswahlBox::Style::Erlaubt | AuswahlBox::Style::Rahmen | AuswahlBox::Style::MausBuffer | AuswahlBox::Style::AuswahlBuffer | AuswahlBox::Style::MaxHeight | AuswahlBox::Style::VScroll | AuswahlBox::Style::Hintergrund );
    gbdMonat->setPosition( 185, 167 );
    gbdMonat->setSize( 65, 20 );
    gbdMonat->setMaxAuskappHeight( 100 );
    gbdMonat->setSchriftZ( zSchrift->getThis() );
    gbdMonat->setRahmenFarbe( 0xFFFFFFFF );
    gbdMonat->setHintergrundFarbe( 0xFF000000 );
    gbdMonat->setMausEreignis( _ret1ME );
    gbdMonat->addEintrag( "Monat" );
    for( int i = 0; i < 12; i++ )
    {
        Text *txt = new Text( "" );
        txt->append( i + 1 );
        gbdMonat->addEintrag( txt );
    }
    gbdJahr = new AuswahlBox();
    gbdJahr->setStyle( AuswahlBox::Style::Sichtbar | AuswahlBox::Style::Erlaubt | AuswahlBox::Style::Rahmen | AuswahlBox::Style::MausBuffer | AuswahlBox::Style::AuswahlBuffer | AuswahlBox::Style::MaxHeight | AuswahlBox::Style::VScroll | AuswahlBox::Style::Hintergrund );
    gbdJahr->setPosition( 255, 167 );
    gbdJahr->setSize( 55, 20 );
    gbdJahr->setMaxAuskappHeight( 100 );
    gbdJahr->setSchriftZ( zSchrift->getThis() );
    gbdJahr->setRahmenFarbe( 0xFFFFFFFF );
    gbdJahr->setHintergrundFarbe( 0xFF000000 );
    gbdJahr->setMausEreignis( _ret1ME );
    gbdJahr->addEintrag( "Jahr" );
    for( int i = 2013; i > 1913; i-- )
    {
        Text *txt = new Text( "" );
        txt->append( i + 1 );
        gbdJahr->addEintrag( txt );
    }
    weiter = initKnopf( 124, 200, 100, 20, zSchrift, Knopf::Style::Sichtbar, "Weiter" );
    weiter->setMausEreignisParameter( this );
    weiter->setMausEreignis( registrierungWeiterME );
    fenster->addMember( weiter->getThis() );
    zVorLoginFenster->addMember( fenster->getThis() );
    fenster->addMember( gbdTag->getThis() );
    fenster->addMember( gbdMonat->getThis() );
    fenster->addMember( gbdJahr->getThis() );
    ref = 1;
}

// Destruktor 
Registrierung::~Registrierung()
{
    if( fenster )
        fenster = (Fenster *)fenster->release();
    if( name )
        name = (TextFeld *)name->release();
    if( passwort )
        passwort = (TextFeld *)passwort->release();
    if( passwort2 )
        passwort2 = (TextFeld *)passwort2->release();
    if( geheimnis )
        geheimnis = (TextFeld *)geheimnis->release();
    if( eMail )
        eMail = (TextFeld *)eMail->release();
    if( geburtsdatum )
        geburtsdatum = (TextFeld *)geburtsdatum->release();
    if( gbdTag )
        gbdTag = (AuswahlBox *)gbdTag->release();
    if( gbdMonat )
        gbdMonat = (AuswahlBox *)gbdMonat->release();
    if( gbdJahr )
        gbdJahr = (AuswahlBox *)gbdJahr->release();
    if( weiter )
        weiter = (Knopf *)weiter->release();
    if( text )
        text = (TextFeld *)text->release();
    if( registrierung )
        registrierung = (Knopf *)registrierung->release();
}

// Privat
void Registrierung::zeigeNachricht( const char *txt )
{
    Punkt bildschirmmitte = Bildschirmmitte();
    name->removeStyle( TextFeld::Style::Sichtbar );
    passwort->removeStyle( TextFeld::Style::Sichtbar );
    passwort2->removeStyle( TextFeld::Style::Sichtbar );
    geheimnis->removeStyle( TextFeld::Style::Sichtbar );
    eMail->removeStyle( TextFeld::Style::Sichtbar );
    geburtsdatum->removeStyle( TextFeld::Style::Sichtbar );
    gbdTag->removeStyle( TextFeld::Style::Sichtbar );
    gbdMonat->removeStyle( TextFeld::Style::Sichtbar );
    gbdJahr->removeStyle( TextFeld::Style::Sichtbar );
    fenster->setSize( 250, 150 );
    fenster->setPosition( bildschirmmitte.x - 125, bildschirmmitte.y - 75 );
    weiter->setPosition( 139, 100 );
    weiter->setText( "Ok" );
    text->setText( txt );
    if( text->zText()->getLength() > 30 )
    {
        int pos = -1;
        bool set = 0;
        int lastp = 0;
        for( int i = 20; i < text->zText()->getLength(); )
        {
            char *tmp = &text->zText()->getText()[ i ];
            while( *tmp != ' ' && i < text->zText()->getLength() )
            {
                tmp++;
                i++;
                if( i - 30 >= lastp )
                {
                    if( set )
                    {
                        lastp = pos;
                        set = 0;
                        text->zText()->getText()[ pos ] = '\n';
                    }
                    else
                        lastp += 5;
                }
            }
            if( i < text->zText()->getLength() )
            {
                pos = i;
                set = 1;
                tmp++;
                i++;
            }
        }
    }
    text->addStyle( TextFeld::Style::Sichtbar );
}

// Knopfdruck
void Registrierung::druckFremdKnopf() // Ein anderer Knopfwurde gedrckt
{
    fenster->removeStyle( Fenster::Style::Sichtbar );
    registrierung->setRahmenBreite( 2 );
    registrierung->setAlphaFeldFarbe( 0x5500FF00 );
    registrierung->setAlphaFeldStrength( -5 );
}

bool Registrierung::nameTE( void *obj, TastaturEreignis te ) // Tastaturereignis im Textfeld name
{
    if( te.id == TE_Press && te.taste == T_Enter )
        return 0;
    if( te.id == TE_Release && ( te.taste == T_Enter || te.taste == T_Tab ) )
    {
        name->removeStyle( TextFeld::Style::Fokus );
        passwort->addStyle( TextFeld::Style::Fokus );
        passwort->setAuswahl( 0, passwort->zText()->getLength() );
    }
    if( name->zText()->getLength() >= 25 && istSchreibbar( te.taste ) )
        return 0;
    return 1;
}

bool Registrierung::passwortTE( void *obj, TastaturEreignis te ) // Tastaturereignis im Textfeld passwort
{
    if( te.id == TE_Press && te.taste == T_Enter )
        return 0;
    if( te.id == TE_Press )
        passwort->setSchowChar( '*' );
    if( te.id == TE_Release && ( te.taste == T_Enter || te.taste == T_Tab ) )
    {
        passwort->removeStyle( TextFeld::Style::Fokus );
        passwort2->addStyle( TextFeld::Style::Fokus );
        passwort2->setAuswahl( 0, passwort2->zText()->getLength() );
    }
    if( passwort->zText()->getLength() >= 25 && istSchreibbar( te.taste ) )
        return 0;
    return 1;
}

bool Registrierung::passwort2TE( void *obj, TastaturEreignis te ) // Tastaturereignis im Textfeld passwort2
{
    if( te.id == TE_Press && te.taste == T_Enter )
        return 0;
    if( te.id == TE_Press )
        passwort2->setSchowChar( '*' );
    if( te.id == TE_Release && ( te.taste == T_Enter || te.taste == T_Tab ) )
    {
        passwort2->removeStyle( TextFeld::Style::Fokus );
        geheimnis->addStyle( TextFeld::Style::Fokus );
        geheimnis->setAuswahl( 0, geheimnis->zText()->getLength() );
    }
    if( passwort2->zText()->getLength() >= 25 && istSchreibbar( te.taste ) )
        return 0;
    return 1;
}

bool Registrierung::geheimnisTE( void *obj, TastaturEreignis te ) // Tastaturereignis im Textfeld geheimnis
{
    if( te.id == TE_Press && te.taste == T_Enter )
        return 0;
    if( te.id == TE_Release && ( te.taste == T_Enter || te.taste == T_Tab ) )
    {
        geheimnis->removeStyle( TextFeld::Style::Fokus );
        eMail->addStyle( TextFeld::Style::Fokus );
        eMail->setAuswahl( 0, eMail->zText()->getLength() );
    }
    int selCount = 0;
    for( int i = 0; i < geheimnis->zText()->getLength(); i++ )
        selCount += (int)geheimnis->isCharSelected( i );
    if( geheimnis->zText()->getLength() - selCount >= 50 && istSchreibbar( te.taste ) )
        return 0;
    return 1;
}

bool Registrierung::eMailTE( void *obj, TastaturEreignis te ) // Tastaturereignis im Textfeld eMail
{
    if( te.id == TE_Press && te.taste == T_Enter )
        return 0;
    if( te.id == TE_Release && ( te.taste == T_Enter || te.taste == T_Tab ) )
    {
        eMail->removeStyle( TextFeld::Style::Fokus );
        gbdTag->addStyle( AuswahlBox::Style::Fokus );
    }
    if( eMail->zText()->getLength() >= 50 && istSchreibbar( te.taste ) )
        return 0;
    return 1;
}

bool Registrierung::weiterME( void *obj, MausEreignis me ) // MausEreignis im Knopf weiter
{
    if( me.id == ME_RLinks )
    {
        Punkt bildchirmGre = BildschirmGre();
        if( fenster->zTitel()->istGleich( "Erfolg" ) )
        {
            text->removeStyle( TextFeld::Style::Sichtbar );
            weiter->setPosition( 124, 200 );
            weiter->setText( "Weiter" );
            fenster->setSize( 350, 262 );
            fenster->setPosition( bildchirmGre.x / 2 - 175, bildchirmGre.y / 2 - 131 );
            fenster->setTitel( "Account erstellen" );
            name->addStyle( TextFeld::Style::Sichtbar );
            passwort->addStyle( TextFeld::Style::Sichtbar );
            passwort2->addStyle( TextFeld::Style::Sichtbar );
            geheimnis->addStyle( TextFeld::Style::Sichtbar );
            eMail->addStyle( TextFeld::Style::Sichtbar );
            geburtsdatum->addStyle( TextFeld::Style::Sichtbar );
            gbdTag->addStyle( TextFeld::Style::Sichtbar );
            gbdMonat->addStyle( TextFeld::Style::Sichtbar );
            gbdJahr->addStyle( TextFeld::Style::Sichtbar );
            name->addStyle( TextFeld::Style::Fokus );
            name->setAuswahl( 0, name->zText()->getLength() );
        }
        else
        {
            if( weiter->zText()->istGleich( "Ok" ) )
            {
                text->removeStyle( TextFeld::Style::Sichtbar );
                weiter->setPosition( 124, 200 );
                weiter->setText( "Weiter" );
                fenster->setSize( 350, 262 );
                fenster->setPosition( bildchirmGre.x / 2 - 175, bildchirmGre.y / 2 - 131 );
                name->addStyle( TextFeld::Style::Sichtbar );
                passwort->addStyle( TextFeld::Style::Sichtbar );
                passwort2->addStyle( TextFeld::Style::Sichtbar );
                geheimnis->addStyle( TextFeld::Style::Sichtbar );
                eMail->addStyle( TextFeld::Style::Sichtbar );
                geburtsdatum->addStyle( TextFeld::Style::Sichtbar );
                gbdTag->addStyle( TextFeld::Style::Sichtbar );
                gbdMonat->addStyle( TextFeld::Style::Sichtbar );
                gbdJahr->addStyle( TextFeld::Style::Sichtbar );
                name->addStyle( TextFeld::Style::Fokus );
                name->setAuswahl( 0, name->zText()->getLength() );
            }
            else if( passwort2->zText()->istGleich( passwort->zText()->getText() ) )
            {
                if( name->zText()->getLength() == 0 ||
                    passwort->zText()->getLength() == 0 ||
                    geheimnis->zText()->getLength() == 0 ||
                    eMail->zText()->getLength() == 0 )
                {
                    if( name->zText()->getLength() == 0 )
                        zeigeNachricht( "Bitte gebe einen Accountnamen ein." );
                    else if( passwort->zText()->getLength() == 0 )
                        zeigeNachricht( "Bitte gebe ein Accountpasswort ein." );
                    else if( geheimnis->zText()->getLength() == 0 )
                        zeigeNachricht( "Bitte gebe ein Accountgeheimnis ein. Die wird bentig, wenn du deinen Accountnamen oder dein Accountpasswort vergisst." );
                    else if( eMail->zText()->getLength() == 0 )
                        zeigeNachricht( "Bitte gebe deine E-Mail Addresse ein. Diese bentigen wir, um dir den Besttigungscode fr deinen Account zu senden." );
                    return 1;
                }
                Datum * gebDat = new Datum();
                gebDat->setDatum( 1, 1, 1 );
                bool ok = 1;
                do
                {
                    if( !gbdTag->getAuswahl() || !gbdMonat->getAuswahl() || !gbdJahr->getAuswahl() )
                    {
                        ok = 0;
                        break;
                    }
                    int jahr = TextZuInt( gbdJahr->zEintrag( gbdJahr->getAuswahl() )->zText()->getText(), 10 );
                    gebDat->setJahr( jahr );
                    gebDat->setMonat( gbdMonat->getAuswahl() );
                    gebDat->setTag( gbdTag->getAuswahl() );
                    if( jahr != gebDat->getJahr() || gbdMonat->getAuswahl() != gebDat->getMonat() || gbdTag->getAuswahl() != gebDat->getTag() )
                    {
                        ok = 0;
                        break;
                    }
                } while( 0 );
                if( ok )
                    new AktionsThread( 15, name->zText()->getText(), passwort->zText()->getText(), geheimnis->zText()->getText(), eMail->zText()->getText(), gebDat->getThis() );
                else
                    zeigeNachricht( "Bitte gebe ein gltiges Geburtsdatum an." );
                gebDat = gebDat->release();
            }
            else
                zeigeNachricht( "Das wiederhohlte Passwort stimmt nicht mit dem Passwort berein." );
        }
    }
    return 1;
}

bool Registrierung::registrierungME( void *obj, MausEreignis me ) // MausEreignis im Knopf registrierung
{
    if( me.id == ME_RLinks )
    {
        vorLogin->setRegistrierung();
        fenster->addStyle( Fenster::Style::Sichtbar );
        registrierung->setRahmenBreite( 3 );
        registrierung->setAlphaFeldFarbe( 0xFF000000 );
        registrierung->setAlphaFeldStrength( 20 );

        Punkt bildchirmGre = BildschirmGre();
        text->removeStyle( TextFeld::Style::Sichtbar );
        weiter->setPosition( 124, 200 );
        weiter->setText( "Weiter" );
        fenster->setSize( 350, 262 );
        fenster->setPosition( bildchirmGre.x / 2 - 175, bildchirmGre.y / 2 - 131 );
        fenster->setTitel( "Account erstellen" );
        name->addStyle( TextFeld::Style::Sichtbar );
        passwort->addStyle( TextFeld::Style::Sichtbar );
        passwort2->addStyle( TextFeld::Style::Sichtbar );
        geheimnis->addStyle( TextFeld::Style::Sichtbar );
        eMail->addStyle( TextFeld::Style::Sichtbar );
        geburtsdatum->addStyle( TextFeld::Style::Sichtbar );
        gbdTag->addStyle( TextFeld::Style::Sichtbar );
        gbdMonat->addStyle( TextFeld::Style::Sichtbar );
        gbdJahr->addStyle( TextFeld::Style::Sichtbar );
        name->addStyle( TextFeld::Style::Fokus );
        name->setAuswahl( 0, name->zText()->getLength() );
    }
    return 1;
}

void Registrierung::setWeiterReturn( bool ret ) // setzt den Weiter Returnwert
{
    Punkt bildchirmGre = BildschirmGre();
    if( ret )
    {
        name->removeStyle( TextFeld::Style::Sichtbar );
        passwort->removeStyle( TextFeld::Style::Sichtbar );
        passwort2->removeStyle( TextFeld::Style::Sichtbar );
        geheimnis->removeStyle( TextFeld::Style::Sichtbar );
        eMail->removeStyle( TextFeld::Style::Sichtbar );
        geburtsdatum->removeStyle( TextFeld::Style::Sichtbar );
        gbdTag->removeStyle( TextFeld::Style::Sichtbar );
        gbdMonat->removeStyle( TextFeld::Style::Sichtbar );
        gbdJahr->removeStyle( TextFeld::Style::Sichtbar );
        fenster->setSize( 250, 200 );
        fenster->setPosition( bildchirmGre.x / 2 - 125, bildchirmGre.y / 2 - 100 );
        fenster->setTitel( "Erfolg" );
        weiter->setPosition( 20, 145 );
        weiter->setText( "Ok" );
        text->setText( "Dir wurde eine E-Mail mit einem\naktivierungslink zugeschickt,\nden du in den nchsten 12 Stunden\nbenutzen musst." );
        text->addStyle( TextFeld::Style::Sichtbar );
    }
    else if( lastError.getLength() )
        zeigeNachricht( lastError );
}

// Reference Counting
Registrierung *Registrierung::getThis()
{
    ref++;
    return this;
}

Registrierung *Registrierung::release()
{
    ref--;
    if( !ref )
        delete this;
    return 0;
}

// Ereignisse
bool registrierungNameTE( void *p, void *obj, TastaturEreignis te )
{
    if( !p )
        return 0;
    return ( (Registrierung *)p )->nameTE( obj, te );
}

bool registrierungPasswortTE( void *p, void *obj, TastaturEreignis te )
{
    if( !p )
        return 0;
    return ( (Registrierung *)p )->passwortTE( obj, te );
}

bool registrierungPasswort2TE( void *p, void *obj, TastaturEreignis te )
{
    if( !p )
        return 0;
    return ( (Registrierung *)p )->passwort2TE( obj, te );
}

bool registrierungGeheimnisTE( void *p, void *obj, TastaturEreignis te )
{
    if( !p )
        return 0;
    return ( (Registrierung *)p )->geheimnisTE( obj, te );
}

bool registrierungEMailTE( void *p, void *obj, TastaturEreignis te )
{
    if( !p )
        return 0;
    return ( (Registrierung *)p )->eMailTE( obj, te );
}

bool registrierungWeiterME( void *p, void *obj, MausEreignis me )
{
    if( !p )
        return 0;
    return ( (Registrierung *)p )->weiterME( obj, me );
}

bool registrierungRegistrierungME( void *p, void *obj, MausEreignis me )
{
    if( !p )
        return 0;
    return ( (Registrierung *)p )->registrierungME( obj, me );
}